package com.asdf.plugins.hello;

import java.awt.Dimension;

import javax.swing.JFrame;
import javax.swing.WindowConstants;

import com.asdf.client.ConnectionHandler;
import com.asdf.common.GameController;
import com.asdf.common.AccountType;
import com.asdf.parser.GameResponse;
import com.asdf.parser.Request;
import com.asdf.parser.Response;
import com.asdf.parser.StateUpdate;


/**
 * An example game framework provided by the ASDF group to get you a quick start
 * on creating your own great games in our game server system. Intended to function
 * as a first tutorial to working with our server software, not as a 
 * tutorial in game programming.
 */

public class HelloGame extends GameController {

	/// ConnectionHandlers will make your life a lot easier. See the javadoc for greater understanding.
	ConnectionHandler connection = null;
	
	/// The game window.
	JFrame helloframe = null;

	
	/**
	 * When the game is started, this method is called. Gives you the chance to do what ever
	 * initializing you might wish to do.
	 */
	@Override
	public void start() {
		helloframe = new JFrame();
		helloframe.setTitle("Hello World!");
		helloframe.setPreferredSize(new Dimension(640,480));
		//JLabel label = new JLabel("Hello World!");
		//helloframe.add(label);
		helloframe.setDefaultCloseOperation(WindowConstants.DISPOSE_ON_CLOSE);
		helloframe.pack();
		helloframe.setVisible(true);
		
	}

	/**
	 * Game logics has sent a response. If you wish to react in some way, write some code here.
	 */
	@Override
	public void handleResponse(Response rsp) {		
		
	}

	/**
	 * Game logics requests something of you, if you want to do something about it, write some code here.
	 */
	@Override
	public void handleRequest(Request req) {
		
	}

	/**
	 * Game logics has sent a state update message, informing you of the new state of the game world.
	 * If you wish to react in some way, for example store the information somewhere, or process your
	 * own game world model, this would be a good time to do so.
	 */
	@Override
	public void handleStateUpdate(StateUpdate stateUp) {
		
	}

	/**
	 * When the client is joining the game for the first time, if he wants to something special about it,
	 * this is the place.
	 */
	@Override
	public void init(GameResponse arg0, String arg1, AccountType arg2) {
		// TODO Auto-generated method stub
		
	}
	
	
	/**
	 * Nothing important.
	 * @param args
	 */
	public static void main(String args[]){
		HelloGame hello = new HelloGame();	
		hello.init(null, " ", AccountType.REGULAR_USER);
		hello.start();
	}





}
