package com.asdf.plugins.pokergames;

import java.io.FileNotFoundException;
import java.io.FileReader;
import java.util.Scanner;

/**
 * Loads and stores precalculated tables to be used for evaluating poker hands
 * @author urtela
 *
 */

public class EvalTables {

public static void main(String[] a)
{
	EvalTables temp = new EvalTables();
	temp.print();
}



/**
 * Reads from a readable source (assumed to be a poker hand evaluation data file) as long as there is something to read, and assingns these values to tables.
 * @param table The table which should be filled with information.
 * @param reader A readable Scanner object.
 */

private void fillTable(int table[], Scanner reader) {
	int counter = 0;
	while(reader.hasNext())
		table[counter++] = reader.nextInt();
}


/**
 * Attempts to open up data files and fill tables with information.
 *
 */

public EvalTables() {

	Scanner r = null;

	try {
		r = new Scanner(new FileReader("data/unique.dat"));
	}
	catch(FileNotFoundException e) {
		throw new RuntimeException("Poker hand evaluation data files not found!");
	}
	unique5 = new int[10000];
	fillTable(unique5, r);

	try {
		r = new Scanner(new FileReader("data/flushes.dat"));
	}
	catch(FileNotFoundException e) {
		return;
	}
	flushes = new int[10000];
	fillTable(flushes, r);

	try {
		r = new Scanner(new FileReader("data/values.dat"));
	}
	catch(FileNotFoundException e) {
		return;
	}
	values = new int[10000];
	fillTable(values, r);

	try {
		r = new Scanner(new FileReader("data/products.dat"));
	}
	catch(FileNotFoundException e) {
		return;
	}
	products = new int[10000];
	fillTable(products, r);

}

public int unique5[];
public int flushes[];
public int products[];
public int values[];

/**
 * For developer debug only.
 * Prints 400 first entries from all precalc-tables.
 */

public void print() {
System.out.println("FLUSHES:");
	for(int i=0; i < 400; i++)
		System.out.print("" + flushes[i] + ", ");
System.out.println("UNIQUES:");
	for(int i=0; i < 400; i++)
		System.out.print("" + unique5[i] + ", ");
System.out.println("PRODUCTS:");
	for(int i=0; i < 400; i++)
		System.out.print("" + products[i] + ", ");
System.out.println("VALUES:");
	for(int i=0; i < 400; i++)
		System.out.print("" + values[i] + ", ");
}

/// Primes for each card rank.
public int primes[] = { 2, 3, 5, 7, 11, 13, 17, 19, 23, 29, 31, 37, 41 };


}
