package com.asdf.plugins.pokergames;

import com.asdf.plugins.pokergames.PokerGame.Blind;
import com.asdf.plugins.pokergames.texasholdem.parser.GameModelInfoMessage;
import com.asdf.plugins.pokergames.texasholdem.parser.PlayerInfoFieldsMessage;

public class OurPlayerInfoFields {
	
	private String myName; //set by constructor
	private int mySeat; //TODO set by something
	
	private Hand holeCards = null; //updated when player reveals, otherwise set to blank cards	
	private double bankRoll = 0; //set with creator, updated with wins and actions
	private GameModelInfoMessage lastGameInfo; //set with actions something?		
	private int myState = 0; //TODO updated with actions, starts by being in game, and active
	private double inPot = 0; //TODO updated with actions
	private double bankRollAtStartOfHand = 0; //TODO updated with actions and zeroed at beginning
	private double inPotThisRound = 0; //TODO updated with actions	
	private int lastAction; //TODO updated with actions
	private boolean hasActedThisRound; //TODO updated with actions
	
	private Blind hasToPostBlind;

	
	public OurPlayerInfoFields() {
		;
	}
	
	public OurPlayerInfoFields(OurPlayerInfoFields previous) {
		this.myName = previous.myName;
		this.mySeat = previous.mySeat;
		this.holeCards = previous.holeCards;
		this.bankRoll = previous.bankRoll;
		this.lastGameInfo = previous.lastGameInfo;
		this.myState = previous.myState;
		this.inPot = previous.inPot;
		this.bankRollAtStartOfHand = previous.bankRollAtStartOfHand;
		this.inPotThisRound = previous.inPotThisRound;
		this.lastAction = previous.lastAction;
		this.hasActedThisRound = previous.hasActedThisRound;
		this.hasToPostBlind = previous.hasToPostBlind;
	}

	public OurPlayerInfoFields(PlayerInfoFieldsMessage playerInfoFieldsMessage) {
		// TODO Auto-generated constructor stub
	}

	/**
	 * @return the myName
	 */
	public String getMyName() {
		return myName;
	}

	/**
	 * @param myName the myName to set
	 */
	public void setMyName(String myName) {
		this.myName = myName;
	}

	/**
	 * @return the mySeat
	 */
	public int getMySeat() {
		return mySeat;
	}

	/**
	 * @param mySeat the mySeat to set
	 */
	public void setMySeat(int mySeat) {
		this.mySeat = mySeat;
	}

	/**
	 * @return the holeCards
	 */
	public Hand getHoleCards() {
		return holeCards;
	}

	/**
	 * @param holeCards the holeCards to set
	 */
	public void setHoleCards(Hand holeCards) {
		this.holeCards = holeCards;
	}

	/**
	 * @return the bankRoll
	 */
	public double getBankRoll() {
		return bankRoll;
	}

	/**
	 * @param bankRoll the bankRoll to set
	 */
	public void setBankRoll(double bankRoll) {
		this.bankRoll = bankRoll;
	}

	/**
	 * @return the lastGameInfo
	 */
	public GameModelInfoMessage getLastGameInfo() {
		return lastGameInfo;
	}

	/**
	 * @param lastGameInfo the lastGameInfo to set
	 */
	public void setLastGameInfo(GameModelInfoMessage lastGameInfo) {
		this.lastGameInfo = lastGameInfo;
	}

	/**
	 * @return the myState
	 */
	public int getMyState() {
		return myState;
	}

	/**
	 * @param myState the myState to set
	 */
	public void setMyState(int myState) {
		this.myState = myState;
	}

	/**
	 * @return the inPot
	 */
	public double getInPot() {
		return inPot;
	}

	/**
	 * @param inPot the inPot to set
	 */
	public void setInPot(double inPot) {
		this.inPot = inPot;
	}

	/**
	 * @return the bankRollAtStartOfHand
	 */
	public double getBankRollAtStartOfHand() {
		return bankRollAtStartOfHand;
	}

	/**
	 * @param bankRollAtStartOfHand the bankRollAtStartOfHand to set
	 */
	public void setBankRollAtStartOfHand(double bankRollAtStartOfHand) {
		this.bankRollAtStartOfHand = bankRollAtStartOfHand;
	}

	/**
	 * @return the inPotThisRound
	 */
	public double getInPotThisRound() {
		return inPotThisRound;
	}

	/**
	 * @param inPotThisRound the inPotThisRound to set
	 */
	public void setInPotThisRound(double inPotThisRound) {
		this.inPotThisRound = inPotThisRound;
	}

	/**
	 * @return the lastAction
	 */
	public int getLastAction() {
		return lastAction;
	}

	/**
	 * @param lastAction the lastAction to set
	 */
	public void setLastAction(int lastAction) {
		this.lastAction = lastAction;
	}

	/**
	 * @return the hasActedThisRound
	 */
	public boolean isHasActedThisRound() {
		return hasActedThisRound;
	}

	/**
	 * @param hasActedThisRound the hasActedThisRound to set
	 */
	public void setHasActedThisRound(boolean hasActedThisRound) {
		this.hasActedThisRound = hasActedThisRound;
	}

	/**
	 * @return the hasToPostBlind
	 */
	public Blind getHasToPostBlind() {
		return hasToPostBlind;
	}

	/**
	 * @param hasToPostBlind the hasToPostBlind to set
	 */
	public void setHasToPostBlind(Blind hasToPostBlind) {
		this.hasToPostBlind = hasToPostBlind;
	}

}
