package com.asdf.plugins.pokergames.gameview;

import java.awt.Color;
import java.awt.GridLayout;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;

import javax.swing.BorderFactory;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.border.Border;

public class GameViewBackGroundSelector extends JPanel implements MouseListener{
	private static final long serialVersionUID = 1L;
	private final Border grayBorder = BorderFactory.createLineBorder(Color.darkGray);
	private GameView gameview;
	JLabel green = new JLabel("");
	JLabel gray = new JLabel("");
	JLabel red = new JLabel("");
	JLabel white = new JLabel("");
	
	/**
	 * BackgroundSelectorPanel, draws small boxes that change background in
	 * given gameview when clicked.
	 * 
	 * @param gv
	 */
	
	GameViewBackGroundSelector(GameView gv){
		gameview= gv;
		 
		GridLayout temp = new GridLayout(1,4);
		temp.setHgap(1);
		this.setLayout(temp);
		this.setOpaque(false);
		for (JLabel jlabel : new JLabel[]{green,red,gray,white}){
			
			jlabel.setBorder(grayBorder);
			jlabel.setOpaque(true);
			jlabel.addMouseListener(this);
			this.add(jlabel);}
		green.setBackground(new Color(89,108,112));
		red.setBackground(new Color(184,43,81));
		gray.setBackground(new Color(42,100,167));
		white.setBackground(Color.white);
		this.setBounds(2,2,40,10);
	}
	
	public void mouseClicked(MouseEvent e) {
		Object source = e.getSource();
		if (source==green) gameview.setBackGround("background");
		if (source==gray) gameview.setBackGround("background2");
		if (source==red) gameview.setBackGround("background3");
		if (source==white) gameview.setBackGround("background4");
	}
	public void mouseEntered(MouseEvent e) { }
	public void mouseExited(MouseEvent e) { }
	public void mousePressed(MouseEvent e) { }
	public void mouseReleased(MouseEvent e) { }

}
