package com.asdf.plugins.pokergames.gameview;

import javax.swing.text.BadLocationException;
import javax.swing.text.SimpleAttributeSet;
import javax.swing.text.StyleConstants;
import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Font;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.BoxLayout;
import javax.swing.JComboBox;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTextField;
import javax.swing.JTextPane;

import com.asdf.plugins.pokergames.PokerGameController;

public class GameViewChatPanel extends JPanel implements ActionListener {


	//private JButton sendVoice = new JButton("Send voice");
	
	private static final long serialVersionUID = 1L;
	private JComboBox chattype =
		new JComboBox(new String[] { "Full detail","Chat only", "No chat" });
	private JTextPane textPane = new JTextPane();
	private JScrollPane textwindow = new JScrollPane(textPane);
	private JTextField chatinput = new JTextField(3);
	private PokerGameController gc;

	GameViewChatPanel() {
		this.setLayout(new BorderLayout());
		textPane.setEditable(false);
		JPanel temp = new JPanel();
		temp.setLayout(new BoxLayout(temp, BoxLayout.X_AXIS));
		temp.add(chatinput);
		chatinput.addActionListener(this);
		chattype.setFont(new Font("verdana", Font.PLAIN, 9));
		
//		sendVoice.addMouseListener(new MouseListener() {
//
//			@Override
//			public void mouseClicked(MouseEvent arg0) {
//			}
//
//			@Override
//			public void mouseEntered(MouseEvent arg0) {
//			}
//
//			@Override
//			public void mouseExited(MouseEvent arg0) {
//			}
//
//			@Override
//			public void mousePressed(MouseEvent arg0) {
//				if (arg0.getButton() == MouseEvent.BUTTON1) {
//					SoundManager.startRecording();
//				}
//				
//			}
//
//			@Override
//			public void mouseReleased(MouseEvent arg0) {
//				if (arg0.getButton() == MouseEvent.BUTTON1) {
//					byte[] data = SoundManager.stopRecording();
//					gc.sendVoice(data);
//				}
//			}
//			
//		});
		
		temp.add(chattype);
//		temp.add(sendVoice);
		this.add(temp, BorderLayout.SOUTH);
		this.add(textwindow, BorderLayout.CENTER);
	}
	
	/**
	 * Appends new chat message to chatpanel.
	 * messages starting with '<' are consdered as chat messages and are darkgray
	 * messages staring with '*' are red, all other messages are blue.
	 *   
	 * @param s Chatmessage.
	 */
	
	public void addChatMessage(String s) {
		try {
			if (chattype.getSelectedItem() == "Chat only" && s.charAt(0) == '<')
				return;
			if (chattype.getSelectedItem() == "No chat" && s.charAt(0) != '<')
				return;
			Color color = Color.blue;
			if (s.charAt(0) == '>')
				color = Color.darkGray;
			else if (s.charAt(0) == '*')
				color = Color.RED;
			SimpleAttributeSet CHAT = new SimpleAttributeSet();
			StyleConstants.setForeground(CHAT, color);
			StyleConstants.setItalic(CHAT, false);
			StyleConstants.setFontFamily(CHAT, "verdana");
			StyleConstants.setFontSize(CHAT, 10);
			textPane.getDocument().insertString(
					textPane.getDocument().getLength(), s + "\n", CHAT);
		} catch (BadLocationException ee) {
			throw new RuntimeException(ee);
		}
		textPane.setCaretPosition(textPane.getDocument().getLength());

	}
	
	/**
	 * Sets controller. Chatpanel directs all messages to that controller
	 * 
	 * @param pgc Controller
	 */
	
	public void setController(PokerGameController pgc) {
		gc = pgc;
	}
	
	/**
	 * Sends chat message.
	 * 
	 */
	
	public void actionPerformed(ActionEvent e) {
		try {
			SimpleAttributeSet SYSTEM = new SimpleAttributeSet();
			StyleConstants.setForeground(SYSTEM, Color.RED);
			StyleConstants.setItalic(SYSTEM, false);
			StyleConstants.setFontFamily(SYSTEM, "verdana");
			StyleConstants.setFontSize(SYSTEM, 10);

			if (gc == null) 
				textPane.getDocument().insertString(
						textPane.getDocument().getLength(),
						"*** CANNOT SEND CHAT MESSAGES IF NOT LOGGED IN ***\n",
						SYSTEM);
			else {
				gc.sendChat(chatinput.getText());
				chatinput.setText("");
			}
			
		} catch (BadLocationException ee) {
			//System.out.println("fsk");
		}
	}
}

