package com.asdf.plugins.pokergames.gameview;

import java.awt.Color;
import java.awt.Font;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;
import javax.swing.ImageIcon;
import javax.swing.JLabel;
import com.asdf.common.Action;


public class GameViewGameButton extends JLabel implements MouseListener{
	
	
	private static final long serialVersionUID = 1L;	
	private int action = 0;
	private double amount = 0;

	private Color color;
	private GameViewButtonPanel gameviewbuttonpanel;
	
	GameViewGameButton(String name, int act, Color c, ImageIcon ico, GameViewButtonPanel gvbp){
		gameviewbuttonpanel = gvbp;
		color = c;
		action = act;
		this.setIcon(ico);
		this.setText(name);
		this.setVerticalTextPosition(JLabel.CENTER);
		this.setHorizontalTextPosition(JLabel.CENTER);
		this.setForeground(c);
		this.setFont(new Font("verdana", Font.PLAIN, 9));
		this.addMouseListener(this);
		
	}
	public void doClick(){
		if (action==Action.RAISE)
			gameviewbuttonpanel.sendRaiseToController(amount);
		else gameviewbuttonpanel.sendActionToController(action);
	}
	
	public void setAmount(double amnt){
		amount = amnt;
	}
		
	public void mouseClicked(MouseEvent e) {
		this.doClick();;		
	}
		
	public void mouseEntered(MouseEvent e) {
		this.setForeground(Color.blue);
	}
	
	public void mouseExited(MouseEvent e) {
		this.setForeground(color);
	}
	
	public void mousePressed(MouseEvent e) {
	}
	
	public void mouseReleased(MouseEvent e) {
	}

}
