package com.asdf.plugins.pokergames.gameview;


import java.awt.Color;
import java.awt.Dimension;
import java.awt.GridLayout;
import java.awt.Toolkit;
import java.awt.event.InputEvent;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;
import javax.swing.BorderFactory;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.border.Border;

/**
 * Supercool resize gizmo, for ones not retard enough to do manual resizes. 
 * @author ASDF
 */

public class GameViewQuickSet extends JPanel implements MouseListener{
	private JLabel[] part = null;
	private Dimension screenSize = Toolkit.getDefaultToolkit().getScreenSize();
	private double sizex,sizey;
	private int nro = 1;
	private JFrame frame;
	private final Border grayBorder = BorderFactory.createLineBorder(Color.darkGray);
	private static final long serialVersionUID = 1L;

/**
 * 
 * @param frm that this gizmo resizes.
 */	
	public GameViewQuickSet(JFrame frm) {
		frame = frm;
		this.setBackground(Color.BLACK);
		setGrid(nro);
	}

	
	private void setGrid(int nro){
		this.removeAll();
		this.setToolTipText("Mouse operated resizegizmo, right click to browse options, left click to choose location and size");
		GridLayout c= null;
		switch(nro){
			case 1:
				c=new GridLayout(2,2);
				part = new JLabel[4];
				sizex = 0.5*screenSize.getWidth();
				sizey = 0.5*screenSize.getHeight();
				break;
			case 2:c=new GridLayout(3,3);
				part = new JLabel[9];
				sizex = 1/3.0*screenSize.getWidth();
				sizey = 1/3.0*screenSize.getHeight();
				break;
			case 3: 
				c=new GridLayout(2,0);
				part = new JLabel[2];
				sizex = screenSize.getWidth();
				sizey = 0.5*screenSize.getHeight();
				break;
			case 4:
				c=new GridLayout();
				part = new JLabel[1];
				sizex = screenSize.getWidth();
				sizey = screenSize.getHeight();
				break;
		}
		this.setLayout(c);
		for (int i=0;i<part.length;i++){
			part[i] = new JLabel("");
			part[i].setOpaque(true);
			part[i].setBorder(grayBorder);
			part[i].addMouseListener(this);
			part[i].setBackground(Color.gray);
			this.add(part[i]);}					
		this.validate();
	}
	
	public void mouseClicked(MouseEvent e) {
		// right click, to change grid
		if ((e.getModifiers() & InputEvent.BUTTON3_MASK) == InputEvent.BUTTON3_MASK){
			nro++;if (nro>4) nro=1;
			setGrid(nro);return;}
		
		// any other click to select resize
		Object source = e.getSource();
		for (int i=0;i<this.getComponentCount();i++){
			
			if (source == part[i]) frame.setBounds(
					(int)(screenSize.getWidth()*(part[i].getX())/(this.getWidth()+1)),
					(int)(screenSize.getHeight()*(part[i].getY())/(this.getHeight()+1)),
					(int)sizex,
					(int)sizey);
		}
	}
	
	public void mouseEntered(MouseEvent e) {
		Object source = e.getSource();
		for (int i=0;i<this.getComponentCount();i++)
			if (source == part[i])
				part[i].setBackground(Color.RED);
	}
	
	public void mouseExited(MouseEvent e) {
		Object source = e.getSource();
		for (int i=0;i<this.getComponentCount();i++)
			if (source == part[i])
				part[i].setBackground(Color.GRAY);
	}
	
	public void mousePressed(MouseEvent e) { }
	public void mouseReleased(MouseEvent e) { }

}
