package com.asdf.plugins.pokergames.gameview;
import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Cursor;
import java.awt.Dimension;
import java.awt.Font;
import java.awt.GridLayout;
import java.awt.Image;
import java.awt.Point;
import java.awt.Rectangle;
import java.awt.Toolkit;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;
import java.net.URL;
import java.util.LinkedList;
import javax.swing.BorderFactory;
import javax.swing.ImageIcon;
import javax.swing.JLabel;
import javax.swing.JLayeredPane;
import javax.swing.JPanel;
import javax.swing.border.Border;

import com.asdf.plugins.pokergames.PlayerInfo;
import com.asdf.plugins.pokergames.PokerGameController;
import com.asdf.utils.Distribution;

public class GameViewSeat implements MouseListener {
	
	private final Border etcBorder = BorderFactory.createEtchedBorder();
	private final Border grayBorder = BorderFactory.createLineBorder(Color.DARK_GRAY);
	private Distribution betpile = null;	
	private JLayeredPane view;
	private JPanel seat,timer;
	private JLabel accountname;
	String gameviewaccount = "";
	private Cursor kick;
	private JLabel
		 bettext, available, name, bank, action, reserved, smallcard, dealer,timerback,timerbar;
	private JLabel[] cards;
	private String[] scards = {"H1","D1","S1","C1","H13","D13","S13"};
	JPanel distChip = new JPanel();
	private LinkedList<GameViewSeat> seats = new LinkedList<GameViewSeat>();
	private int cardX, cardY, seatnro = 0;
	private double seatX, seatY;
	private int[] selected;
	private PokerGameController gc = null;
	public Point centerOfSeat = new Point(0,0);
	private boolean cardsknown = false;
	private double prevbet=-1;
	
	/**
	 * 
	 * @param table      - LayeredPane from frame we want to do all seat releated things
	 * @param x          - relative x position of this seat. 
	 * @param y	         - relative y position of this seat.
	 * @param maxcards   - maxcards dealt in seats in this game
	 * @param l          - list to other existing or future seats in this table
	 * @param seat_nro   - seat number 
	 */
	
	GameViewSeat (JLayeredPane table,
				  int x, 
				  int y,
				  int maxcards,
				  LinkedList<GameViewSeat> l,
				  int seat_nro,
				  boolean discardable) {
		Toolkit toolkit = Toolkit.getDefaultToolkit();
		/* Try first to load image from resource and then from file
		 * if that fails.
		 */
		Image ii;
		URL url = getClass().getResource("/images/kick.gif");
		if (url == null)
			ii = toolkit.getImage("images/kick.gif");
		else
			ii = toolkit.getImage(url);
		
		
		kick = toolkit.createCustomCursor(ii, new Point(8,8), "Kick");
		seatnro = seat_nro;
		seats = l;
		seatX = x/100.0; seatY = y/100.0;
		cards = new JLabel[maxcards];
		view = table;
		
		view.add(seat = new JPanel());
		view.add(timer= new JPanel());
		view.add(available = new JLabel("SEAT AVAILABLE",JLabel.CENTER));
		seat.setVisible(false);
		seat.addMouseListener(this);
		timer.setVisible(false);
		available.setVisible(false);
		available.setBackground(Color.gray);
		available.setOpaque(true);
		available.setBorder(etcBorder);
		available.setForeground(Color.white);		
		timer.setOpaque(true);
		timer.setBorder(grayBorder);
		timer.setLayout(new BorderLayout());
		timer.add(timerbar = new JLabel(""),BorderLayout.WEST);
		timer.add(timerback = new JLabel(""),BorderLayout.CENTER);
		timer.setVisible(false);
		timerback.setOpaque(true);
		timerbar.setOpaque(true);
		timerbar.setBackground(Color.green);
		timerback.setBackground(Color.BLACK);
		seat.setOpaque(true);
		seat.setBorder(grayBorder);
		seat.setLayout(new GridLayout(3,1));
		seat.add(name = new JLabel("",JLabel.CENTER));
		seat.add(bank = new JLabel("",JLabel.CENTER));
		seat.add(action = new JLabel("",JLabel.CENTER));
		view.add(distChip);
		
		distChip.setOpaque(false);
		accountname=new JLabel("",JLabel.CENTER);
		accountname.setOpaque(true);
		accountname.setVisible(false);
		accountname.setBorder(grayBorder);
		accountname.setBackground(new Color (87,168,223));
		accountname.setForeground(Color.white);
		view.add(accountname);
		view.setLayer(accountname,4353454);
		distChip.setVisible(true);
		distChip.setLayout(null);
		bettext=new JLabel("",JLabel.CENTER);
		bettext.setForeground(Color.white);
		
		for (JLabel jlabel : new JLabel[] {available,action,bank,bettext,accountname})
			jlabel.setFont(new Font("verdana", Font.PLAIN, 10));
		view.add(smallcard = new JLabel(""));
		smallcard.setVisible(false);
		view.add(dealer = new JLabel (""));
		dealer.setVisible(false);
		bettext.setVisible(false);
		view.add(bettext);
		view.add(reserved = new JLabel (""));
		reserved.setVisible(false);
		view.setLayer(available,3000); 
		view.setLayer(seat,3000);
		view.setLayer(smallcard,2000);
		view.setLayer(reserved,3002);
		view.setLayer(dealer,50051);
		view.setLayer(timer,50000);
		view.setLayer(bettext,2001);
		view.setLayer(distChip, 1000);
		for (int i=0; i < maxcards;i++){
			view.add(cards[i] = new JLabel(""));
			cards[i].setVisible(false);
		  	cards[i].setOpaque(true);	
		  	cards[i].setBorder(grayBorder);
		  	view.setLayer(cards[i], 1000+i);
		}
		selected = new int[maxcards];
		for (int i=0;i<cards.length;i++)selected[i]=0;
		
		if (discardable)
			for (int i=0;i<cards.length;i++)
				cards[i].addMouseListener(this);
	
	}

	/**
	 * marks cards as known/unknown so that gamemodel doesnt overwrite known cards. 
	 * @param b
	 */
	
	public void setCardsKnown(boolean b){
		cardsknown=b;
	}
	
	/**
	 * returns as boolean if cards are set as known.
	 * @return is cards known
	 */
	
	
	public boolean isCardsKnown(){
		return cardsknown;
	}
	
	public void setGameViewAccountName(String s){
		gameviewaccount = s;
	}
	
	/**
	 * sets all cards disabled. Used to show if cards are folded or not part of winning hand.
	 */
	
	public void setCardsDisable(){
		for (int i=0;i<cards.length;i++)
			cards[i].setEnabled(false);
		smallcard.setVisible(false);
	}
	
	/**
	 * Gives amount of cards we created seat/game
	 * @return the length of cards.
	 */
	
	public int getCardCount(){
		return cards.length;
	}
	
	/**
	 * Sets given cards as enabled or not-enabled. 
	 * @param i given card number
	 * @param b toggle true/false to enabled  
	 */
	
	public void enableCard(int i,boolean b){
		if (i>=0 && i < cards.length)
			cards[i].setEnabled(b);
	}
	public void enableCards(boolean b){
		for (int i=0;i<cards.length;i++)
			cards[i].setEnabled(b);
	}
	/**
	 * Method that places and resizes everything that is located near seat:
	 * smallcards, dealerbutton, reservedbutton, cards, timer, playerseat,
	 * distributed betchips, bet text. 
	 *  
	 * @param x width of playarea
	 * @param y height of playarea
	 * @param xratio width ratio of pictures and seat.
	 * @param yratio height ratio of picutres and seat.
	 */
	
	public void bounds(int x,int y,double xratio,double yratio) {
		
		if (x == 0 || y ==0 || xratio < 0 || yratio < 0) return;
		centerOfSeat = new Point((int)(seatX*x),(int)(seatY*y));
		
		final int LEFT = 1;
		final int RIGHT = 2;
		final int TOP = 3;
		final int BOTTOM = 4;
		final int CENTER = 5;
		int alingX = 0;
		int alingY = 0;
		
		
		
		if (seatX < 0.2) alingX = LEFT;
			else if (seatX > 0.8) alingX = RIGHT;
				else alingX = CENTER;
		
		if (seatY < 0.3) alingY = TOP;
			else if (seatY > 0.65) alingY = BOTTOM;
				else alingY = CENTER;
		
		cardY = (int)(GameView.cardsizeY*yratio);
		cardX = (int)(GameView.cardsizeX*xratio);
		
		int width = (int)(110*xratio);
		int height = (int)(50*yratio);

		
		// box where information of seated player is drawn.
		seat.setBounds (
				(int)(seatX*x-width/2),
				(int)(seatY*y),
				width,
				height);
		
		// box that shows that seat is available.
		
		available.setBounds(
				(int)(seatX*x-width/2+1),
				(int)(seatY*y),
				width-2,
				height);
		
		// location of turntimer.
		timer.setBounds (
				(int)(seatX*x-width/2)+2,
				(int)(seatY*y)+(height)-height/4-2,
				width-4,
				height/4);
		
		accountname.setBounds(seat.getBounds());
		
		int offsetX = (int)(x*seatX)-width/2;
		int offsetY = (int)(y*seatY)-(cardY)+height;
		
		int tempwidth = width;
		
		int offsetwidth = 0;
		
		if (cards.length > 5) tempwidth += (int)(80*xratio);
			else if (cards.length > 3) tempwidth += (int)(60*xratio);
		int step = 0;

		if (cards.length-1 > 0) {		
			step = ((tempwidth-cardX)/(cards.length-1));
			offsetwidth = (cardX+(cards.length-1)*step)-width;}
		
		
		if (alingX == RIGHT) 
			offsetX-=offsetwidth; 
		else if (alingX != LEFT)
			offsetX-=offsetwidth/2;
		
		
		for (int i=0; i < cards.length;i++) {
		cards[i].setBounds(
				   offsetX+step*i,
				   offsetY+selected[i],
				   cardX,
				   cardY);
		cards[i].setIcon(GameView.getIconFromBufferedimage(scards[i],xratio,yratio));
			view.setLayer(cards[i],2000+i);
		}
	
	
		for (JLabel jlabel : new JLabel[] {smallcard,reserved}){		
			if (jlabel == reserved) jlabel.setIcon(GameView.getIconFromBufferedimage("reserved",xratio,yratio));
				else jlabel.setIcon(GameView.getIconFromBufferedimage("small",xratio,yratio));
	
			int wi = jlabel.getIcon().getIconWidth();
			int he = jlabel.getIcon().getIconHeight();
			offsetX = (int)(x*seatX);
			offsetY = (int)(y*seatY);
			
			if (alingX == RIGHT) 
				offsetX-=wi+width/2+1;
			
			else if (alingX == LEFT)
				offsetX+=width/2+1;
			else offsetX-=wi/2;
			
			if (alingY == BOTTOM)
				{ offsetY-=he+1;
				if(alingX == RIGHT || alingX == LEFT)offsetY+=he/4;
				}
				else if (alingY != TOP);
				else {
					if(alingX == RIGHT || alingX == LEFT)offsetY-=he/4;
					offsetY+=height+1;
				}
			
			
			jlabel.setBounds(offsetX,
				    offsetY,
				    wi,
                    he);
		}
	
		dealer.setIcon(GameView.getIconFromBufferedimage("dealer",xratio,yratio));
		int wi = dealer.getIcon().getIconWidth();
		int he = dealer.getIcon().getIconHeight();
		int smallheight = smallcard.getIcon().getIconHeight();
		int smallwidth = smallcard.getIcon().getIconWidth();
		offsetX = (int)(x*seatX);
		offsetY = (int)(y*seatY);
		
		
		if(alingX == LEFT){
			offsetX+=width/2+1;
			if (alingY == BOTTOM){
				offsetY+=smallheight/4;
				if(cards.length > 1)offsetX+=offsetwidth;
			} else {
				offsetY+=height;
				offsetX-=wi;
			}
		} else if(alingX == RIGHT){
			offsetX-=width/2+1+wi;
			if (alingY == BOTTOM){
				offsetY+=smallheight/4;
				if(cards.length > 1) offsetX-=offsetwidth;
			} else {
				offsetY+=height;
				offsetX+=wi;
			}
		} else { // (alingX=CENTER
			if (seatX < 0.5)  offsetX+=width/2;
			else offsetX-=width/2+wi;
			if (alingY==BOTTOM){
				if(cards.length < 4)offsetY-=he;
				else offsetY-=(cardY)+height+he;
			} else offsetY +=height; //alingX=TOP
		}
		dealer.setBounds(offsetX,
			    offsetY,
			    wi,
                he);
		
		offsetX = seat.getBounds().x;
		offsetY = seat.getBounds().y;
		wi=width;
		he=height;
		if (alingX==LEFT) offsetX+=width+smallwidth;
		else if (alingX==RIGHT) offsetX-=wi+smallwidth;
		else if (alingY==TOP) offsetY+=height+smallheight;
		else if (alingY==BOTTOM) offsetY-=cardY-height+he;
		
		if (alingY==TOP && (alingX == LEFT || alingX == RIGHT))
			offsetY+=smallheight/5+he;
		else if (alingY==BOTTOM && (alingX == LEFT || alingX == RIGHT))
			if (cards.length<4)offsetY=smallcard.getBounds().y-he;
			else offsetY+=height-cardY-he;
		else if (alingY==CENTER);//offsetY+=smallheight;
		distChip.setBounds(
				 offsetX,
				 offsetY,
				 wi,
				 he);
		bettext.setBounds(
				 offsetX,
				 offsetY,
				 wi,
				 he);
		chipDraw(xratio,yratio);
	}
	
	
	/**
	 * Returns seat number of this seat. 
	 */
	
	public int getSeatNro() {
		return seatnro; }
	
	/**
	 * draw bet distribution for this seat.  
	 * 
	 * @param xratio
	 * @param yratio
	 */
	
	public void chipDraw(double xratio,double yratio){
		if (betpile==null) return;
		distChip.removeAll();
		view.remove(distChip);
		ImageIcon[] chips = new ImageIcon[8];
		for (int n=0;n<8;n++){
			chips[n] = GameView.getIconFromBufferedimage("chip"+(n+1),xratio,yratio);
		}
		int width = chips[0].getIconWidth();
		int height = chips[0].getIconHeight();
		for (int i=0;i<betpile.chips.size();i++){
			int value = betpile.chips.get(i).value;
			ImageIcon image = chips[value & 7];
			int x = (betpile.chips.get(i).off_x+distChip.getWidth()/2);
			int y = (betpile.chips.get(i).off_y+distChip.getHeight()/2);
			
			JLabel foo = new JLabel(image);
						  foo.setBounds(x,
			              y,
			              width,
			              height);
			distChip.add(foo);
		}
		view.add(distChip);
		view.setLayer(distChip, 1000);
	}
	/**
	 * Updates bettext.
	 * Creates new distribution of chip presentation if bet has changed from previous 
	 * @param visible visible switch
	 * @param amount amount of bet
	 */
	public void setBet (boolean visible, double amount, double xratio, double yratio){
		bettext.setText(""+amount);
		bettext.setVisible(visible);
		// do only new distribution presentation of chips if bet has changed.
		if (amount!=prevbet){
			betpile = com.asdf.utils.ChipSpreader.distribute(amount);
			chipDraw(xratio,yratio);
		}
		prevbet=amount;
		}
	
	/**
	 * Draw dealer button true/false near this seat. 
	 */
	
	public void setDealer (boolean b) { dealer.setVisible(b); } 
	
	/**
	 * Show this seat as reserved seat true/false
	 */
	
	public void setReserved (boolean b) { 
		reserved.setVisible(b);
		if (b){ hideAll();
			this.setAvailable(false, null);
		}
	}
	
	/**
	 * Draw available seats if visible and attach gamecontroller to pass messages. 
	 * 
	 * @param visible    - Toggle if seat is available
	 * @param tgc  - Gamecontroller that forwards message if player wants to sit. 
	 */
	public void setAvailable (boolean visible, PokerGameController tgc) {
		
		gc = tgc;
		available.setVisible(visible);
		if(visible){
			hideAll();
			available.addMouseListener(new MouseAdapter() {
				public void mouseClicked(MouseEvent e) {
					for (GameViewSeat seat: seats)
						seat.available.setVisible(false);
						gc.reserveSeat(seatnro);
	    				}});
		}
	}
	
	/**
	 * hides timerbar
	 */
	
	public void setTimerVisible(boolean b){
		timer.setVisible(b);
		view.updateUI();
	}
	
	/**
	 * Draws timer with ratio of current/max
	 * 
	 * @param currenttimer
	 * @param maxtimer
	 */
	
	public void drawTimer(double currenttimer,double maxtimer){
		int width = timer.getWidth();
		
		if (1.0 * currenttimer / (maxtimer) < 0.1)
			timerbar.setBackground(Color.red);
		else if (1.0 * currenttimer / (maxtimer) < 0.5)
			timerbar.setBackground(Color.orange);
		else
			timerbar.setBackground(Color.green);
		if (currenttimer != 0)
			width = (int) (width * (currenttimer / (maxtimer)));
		int height = timer.getHeight();
		timerbar.setMinimumSize(new Dimension((int) (width), height));
		timerbar.setMaximumSize(new Dimension((int) (width), height));
		timerbar.setPreferredSize(new Dimension((int) (width), height));
		timer.updateUI();
	}

	/**
	 * Hide all graphic components except reserved and dealer buttons.
	 * (bet distribution is hidden in setbet)
	 */
	
	public void hideAll (){
		for (int i=0; i < cards.length;i++) 
			cards[i].setVisible(false);
		seat.setVisible(false);
		smallcard.setVisible(false);
	}
	/**
	 * hides all card components.
	 *
	 */
	public void hideCards (){
		for (int i=0; i < cards.length;i++) 
			cards[i].setVisible(false);
		smallcard.setVisible(false);
	}
	/**
	 * Clear visible cards from this seat.
	 * Draw presentation of smallcard image if player is ingame
	 */
	
	public void setcards (boolean ingame){
		for (int i=0;i<cards.length;i++)
			cards[i].setVisible(false);
		smallcard.setVisible(ingame);
	}
	
	/**
	 * sets visible cards for this player, parameters decide how they are shown.
	 * 
	 * @param enabled if cards are not enabled draw them as gray.
	 * @param s            - all cards that this seat has given as string.
	 */
	
	public void setCards (boolean enabled, String[] s,double xratio, double yratio){
		smallcard.setVisible(false);
		if (s == null) {
			for (int i = 0; i < cards.length; i++)
				cards[i].setVisible(false);
		} else {
			for (int i = 0; i < s.length && i < cards.length; i++) {
				cards[i].setEnabled(enabled);
				cards[i].setIcon(GameView.getIconFromBufferedimage(s[i],xratio,yratio));
				scards[i] = s[i];
				cards[i].setVisible(true);
			}
		}
	}
	
	/**
	 * sets playerinfo to this seat 
	 * 
	 * @param enabled    	- folded/sitdown shows background as darker shade of gray  
	 * @param accountname_	- player's accountname
	 * @param name_
	 * @param bank_    		- players bankaccount
	 * @param action_  		- playesr latest action
	 */
	
	public void setSeat (boolean enabled , String accountname_, String name_, double bank_, String action_){
		accountname.setText(accountname_);
		seat.setVisible(true);
		Color textcol = Color.BLACK;
		Color backcol = Color.LIGHT_GRAY;
		if (!enabled) {
			textcol = Color.LIGHT_GRAY;
			backcol = Color.gray;
		}
		seat.setBackground(backcol);
		name.setForeground(textcol);
		bank.setForeground(textcol);
		action.setForeground(textcol);
		
		name.setText(name_);
		if (bank_>0) bank.setText(""+bank_);
			else bank.setText("0");
		action.setText(action_);
	}
	
	/**
	 * Gives center of seat,  
	 * @return center point of the seat
	 */
	
	public Point getCenter(){
		return centerOfSeat;
	}

	public void mouseClicked(MouseEvent e) {
		Object source = e.getSource();
		for (int i = 0; i < cards.length; i++)
			if (source == cards[i]) {
				if (selected[i] == 10)
					selected[i] = -10;
				else
					selected[i] = 10;
				Rectangle old = cards[i].getBounds();
				cards[i].setBounds(
						(int) old.getX(), 
						(int) old.getY() - selected[i], 
						(int) old.getWidth(), (int) old.getHeight());
			}
		if (source == seat && gc!=null){
			PlayerInfo p = gc.getGameInfo().getPlayer(seatnro);
			if (p!=null)
				if ((p.getBankRoll()==0 && !p.inGame()) ||
			   (gc.getOurPlayer() != this.seatnro && accountname.getText().equalsIgnoreCase(this.gameviewaccount)))
				gc.removePlayer(this.seatnro,false);
		}
	}

	public void mouseEntered(MouseEvent e) {
		Object source = e.getSource();
		
		if (source == seat && gc != null){
			PlayerInfo p = gc.getGameInfo().getPlayer(seatnro);
	        if (p!=null)
	        	if (p.getBankRoll()==0 && !p.inGame())
				accountname.setCursor(kick);
			if (accountname.getText().equalsIgnoreCase(this.gameviewaccount)
				&& gc.getOurPlayer() != this.seatnro)
					seat.setCursor(kick);
				else accountname.setVisible(true);
		
		}
	}
	public void mouseExited(MouseEvent e) {
		Object source = e.getSource();
		if (source == seat || source == accountname){
			seat.setCursor(new Cursor(Cursor.DEFAULT_CURSOR));
			accountname.setCursor(new Cursor(Cursor.DEFAULT_CURSOR));
			accountname.setVisible(false);
		}
	}
	
	public void mousePressed(MouseEvent e) { }
	
	public void mouseReleased(MouseEvent e) { }
}

