package com.asdf.plugins.pokergames.gameview;

import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Dimension;
import java.awt.Font;
import java.awt.GridLayout;
import java.awt.Point;
import java.awt.Rectangle;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.KeyEvent;
import java.awt.event.KeyListener;
import java.io.File;
import java.io.FileNotFoundException;
import java.util.HashMap;
import java.util.Map;
import java.util.Scanner;

import javax.swing.BorderFactory;
import javax.swing.BoxLayout;
import javax.swing.ButtonGroup;
import javax.swing.JButton;
import javax.swing.JCheckBox;
import javax.swing.JComboBox;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JTextField;
import javax.swing.Timer;
import javax.swing.border.Border;

import com.asdf.client.PluginLoader;
import com.asdf.common.PluginLoadException;
import com.asdf.plugins.pokergames.Player;
import com.asdf.plugins.pokergames.PokerGameController;

public class GameViewSitDownPopUp implements ActionListener, KeyListener{
	
	private static final String META_FILES_DIRECTORY = "bots/meta";
	
	private final Border etcBorder = BorderFactory.createEtchedBorder();	
	private ButtonGroup buttongroup = new ButtonGroup();
	private JCheckBox max, min, set, bot;
	private JComboBox bots;
	private JTextField amount;
	private JTextField sessionname;
	private JFrame frame;
	private JButton ok,cancel;
	private PokerGameController gc;
	private String name;
	private int seatnro;
	private double bank,minblind,maxblind;
	private String[] MONIVALINTANICK =
	{
			"Judo","Makuuhuone","Keittioveitsi","Lentopallomaila","Sarvijaakko","Etana","BumbleBee","TaikaSieppo",
			"Seemo","Omena","Sukkanauha","VMTL","RubbieWelliams","Kesaloma","VuokraAuto","Ohjaaja","TitoTrainer","Mustanaamari",
			"Kissa","Koira","Karvinen","Vesansukat","Suvi","Mika","Ambulanssi","Liisa","Pokemon","Tupu","Lapio",
			"Saapas","HamePantteri","Juustoraastin","HameKangas","Loylykauha","MakkoYlatalo","alkkaKinerva","Potsi",
			"Rollipaukku","Spede","Vihtahosu","Bolbobobitti","Alaguln","Saapassieppo","KanaKauppias","RTEEMF","HTML","FSK",
			"skuuma","AKSML","JUBX","Viltteri","KakaKepo","Kooma","Jeelus","Molyapina","Kirahvi","Simpanssi","NaapurinTytto",
			"palipula","Desturbed","Zled","Lunkkali","Brutney","Madonna","Seppo","ArvaaMikaPaiva","Perjantai","Puuppa","Pelsjalkanen","Ankka","Vasala","nuthack","Tourist",
			"ElfTokken","NullPointer","MutsikToGothering","Mugic","BlooMana","Sammakko","IceSkateUphill"};

	private Map<String, String> botClassNames;
	private PluginLoader botLoader;
	private Timer timer;
	
	/**
	 * create new popupwindow from player to join game.
	 * 
	 */
	
	GameViewSitDownPopUp(String name_,int seat_nro,double min_blind,double max_blind,PokerGameController tgc,Point center){
		
		botClassNames = new HashMap<String, String>();
		botLoader = new PluginLoader();
		name = name_;
		seatnro = seat_nro;
		minblind = min_blind;
		maxblind = max_blind;
		gc=tgc;
		frame = new JFrame(name);
		frame.setMaximizedBounds(new Rectangle(0,0,100,150));
		frame.setMinimumSize(new Dimension(100,150));
		frame.setMaximumSize(new Dimension(100,150));
		frame.setAlwaysOnTop(true);
		frame.setSize(1200,1000);
		int x = center.x;
		int y = center.y;
		frame.setLocation(new Point(x-100,y-50));
		frame.setLayout(new BorderLayout(2,2));
		frame.setResizable(false);
		JPanel p = new JPanel();
		JPanel setamount = new JPanel();
		JPanel playername = new JPanel();
		playername.setLayout(new GridLayout(4,1));
		playername.setBorder(etcBorder);
		p.setLayout(new BoxLayout(p, BoxLayout.Y_AXIS));
		playername.add(new JLabel("Set nickname",JLabel.CENTER));
		
		playername.add(sessionname = new JTextField(
				this.MONIVALINTANICK[(int)(Math.random()*(this.MONIVALINTANICK.length-1))]));
	
		playername.add(bot = new JCheckBox("Add a bot:"));
		getBotClassNames();
		playername.add(bots = new JComboBox(botClassNames.keySet().toArray()));
	
		JPanel blindoptions = new JPanel();
		p.add(playername);
		blindoptions.setLayout(new GridLayout(4,1));
		blindoptions.setBorder(etcBorder);
		blindoptions.add(new JLabel("Bring money to table:",JLabel.CENTER));
		blindoptions.add(min = new JCheckBox("minimum("+minblind+")"));
		blindoptions.add(max = new JCheckBox("maximum("+maxblind+")"));
		setamount.setLayout(new BoxLayout(setamount, BoxLayout.X_AXIS));
		setamount.add(set = new JCheckBox("Set amount"));
		setamount.add(amount = new JTextField());
		amount.addKeyListener(this);
		sessionname.addKeyListener(this);
		amount.addActionListener(this);
		sessionname.addActionListener(this);
		min.setSelected(true);
		min.addActionListener(this);
		max.addActionListener(this);
		set.addActionListener(this);
		for (JCheckBox jbox : new JCheckBox[] {min,set,max}){
			jbox.setFont(new Font("verdana", Font.PLAIN, 8));
			buttongroup.add(jbox);
		}
		
		blindoptions.add(setamount);
		p.add(blindoptions);
		JPanel pp = new JPanel();
		pp.setLayout(new GridLayout());
		pp.add(ok = new JButton("OK"));
		pp.add(cancel =new JButton("CANCEL"));
		ok.addActionListener(this);
		cancel.addActionListener(this);
		p.add(pp);
		
		timer = new Timer(26000, this);
		timer.start();
		
		frame.add(p);
		frame.pack();
        frame.setVisible(true);

	}
	public void close(){
		frame.dispose();
	}
	
	public boolean verify(JTextField input) {
	    
        String text = input.getText().trim();
        if(text.length()==0)return false;
        double i;
        try {
            if(text == null || text.equalsIgnoreCase(""))
                i = 0;
            else
                i = new Double(text);            
         } catch (NumberFormatException e){
             return false;
         } 
         if(i >= 0)
             return true;
         else
             return false;
     }
	
	
	public void actionPerformed(ActionEvent e) {
		Object source = e.getSource();
		if (source == ok) {
			timer.stop();
			if (min.isSelected())
				bank = minblind;
			else if (max.isSelected())
				bank = maxblind;
			else if (!verify(amount))
				bank = minblind;
			else {
				bank = Double.valueOf(amount.getText());
				if (bank > maxblind)
					bank = maxblind;
				if (bank < minblind)
					bank = minblind;
			}
			if (bot.isSelected()) {
				try {
					//System.out.println(botClassNames.get(bots.getSelectedItem()));
					gc.addBot(seatnro, sessionname.getText(),
							(Player) botLoader.loadObject(botClassNames.get(bots.getSelectedItem())), 
							bank);
				} catch (PluginLoadException e1) {
					System.err.println("Selected bot could not be loaded. Either bot file is not in \bots" +
							" directory or metafile describing the bot was malformed.");
					//e1.printStackTrace();
				}
			} else
				gc.addPlayer(seatnro, sessionname.getText(), bank);
			frame.dispose();
		} else if (source == cancel) {
			frame.dispose();
			gc.standing();
		} else if ((source == min || source == max) && sessionname.getText().length() > 0)
			ok.setEnabled(true);
		else if (source == set)
			ok.setEnabled(verify(amount) && sessionname.getText().length() > 0);
		else if (source == amount || source == sessionname) {
			if (verify(amount) && sessionname.getText().length() > 0) {
				if (bot.isSelected()) {
					try {
						//System.out.println(botClassNames.get(bots.getSelectedItem()));
						gc.addBot(seatnro, sessionname.getText(),
								(Player) botLoader.loadObject(botClassNames.get(bots.getSelectedItem())), 
								bank);
					} catch (PluginLoadException e1) {
						System.err.println("Selected bot could not be loaded. Either bot file is not in \bots" +
						" directory or metafile describing the bot was malformed.");
						//e1.printStackTrace();
					}
					// gc.addBot(seatnro, sessionname.getText(), new
					// SuperBot(seatnro), bank);
				} else
					gc.addPlayer(seatnro, sessionname.getText(), bank);
				frame.dispose();
			}
		}else if(source == timer){
			timer.stop();
			gc.standing();				
			frame.dispose();
		}
	}
	
	public void keyReleased(KeyEvent e) {
		Object source = e.getSource();
		if (source == amount){
			set.setSelected(true);
			ok.setEnabled(verify(amount) && sessionname.getText().length()>0);
			if(verify(amount))amount.setForeground(Color.black);
				else amount.setForeground(Color.red);
		} else if (source == sessionname){
			ok.setEnabled(sessionname.getText().length() > 0);
		}
		
	}
	public void keyTyped(KeyEvent e) { }
	
	public void keyPressed(KeyEvent e) { }
	
	/**
	 * Reads meta data about bots available in bots directory.
	 */
	private void getBotClassNames() {
		File metaFilesDir = new File(META_FILES_DIRECTORY);
		if(metaFilesDir.isDirectory()) {
			String metaFiles[] = metaFilesDir.list();
			//System.out.println("Found " + metaFiles.length + " bot descriptor meta files.");
			//Logger.get().finest("Found " + metaFiles.length + " game descriptor meta files.");
			for(int i = 0; i < metaFiles.length; i++) {
				File metaFile = new File(META_FILES_DIRECTORY +"/" + metaFiles[i]);
				String s_temp = null;
				String c_temp = null;
				if(true) {
					Scanner sc;
					try {
						sc = new Scanner(metaFile);
					} catch (FileNotFoundException e) {
						//System.out.println("Game meta descriptor returned by file list not found??!");
						continue;
					}
					
					//System.out.println("Reading meta file " + i);
					
					while(sc.hasNextLine()) {
						String line = sc.nextLine();
						Scanner in_s = new Scanner(line);
						while(in_s.hasNext()) {
							String s = in_s.next();
							if(s.charAt(0) == '#')
								break;
							if(s.toLowerCase().equals("classname") && in_s.hasNext()) {
								if(!in_s.hasNext())
									continue;
								c_temp = in_s.next();
								//System.out.println("Found classname tag. Name was: " + s_temp);								
								break;
							}				
							if(s.toLowerCase().equals("botname") && in_s.hasNext()) {
								if(!in_s.hasNext())
									continue;
								s_temp = in_s.next();
								//System.out.println("Found botname tag. Name was: " + s_temp);								
								break;
							}		
						}
					}
					if(c_temp != null && s_temp != null)
						botClassNames.put(s_temp, c_temp);

				}
			}
		} else {
			System.err.println("Bot meta files directory \"/bots/meta\"not found!");
		}
	}
	
	
}
