package com.asdf.plugins.pokergames.texasholdem;

import javax.swing.SwingUtilities;

import com.asdf.common.PokerGameTypes;
import com.asdf.plugins.pokergames.Hand;
import com.asdf.plugins.pokergames.PokerGameController;
import com.asdf.plugins.pokergames.gameview.GameView;

public class TexasGameController extends PokerGameController {
	
	
	/**
	 * Starts Texas Hold'em game client.
	 */
	@Override
	public void start() {
		//Lisäys;
		Runnable doWorkRunnable3 = new Runnable() {
			public void run() {
				gameView = new GameView(2, gameModel.getMaxPlayers(), PokerGameTypes.values()[gameModel.getLimitStyle()], ACTION_WAIT);
			}
		};
		SwingUtilities.invokeLater(doWorkRunnable3);
		//this.gameView = new GameView(2, this.gameModel.getMaxPlayers(), PokerGameTypes.values()[this.gameModel.getLimitStyle()], this.ACTION_WAIT);
		//gameView.update(getGameInfo());
		Runnable doWorkRunnable = new Runnable() {
		    public void run() { 
		    	gameView.update(getGameInfo());    
		    }
		};
		SwingUtilities.invokeLater(doWorkRunnable);
		Runnable doWorkRunnable2 = new Runnable() {
		    public void run() { 
		    	gameView.update(getThis(), playerCanSit());    
		    }
		};
		SwingUtilities.invokeLater(doWorkRunnable2);		
	}

	@Override
	protected void receiveWinEvent(int seat_, double amount, int[] winningCardPositions_) {
		final int seat = seat_;
		final int[] winningCardPositions = winningCardPositions_;
		if (firstHand) {
			if (!SwingUtilities.isEventDispatchThread()) {
				Runnable doWorkRunnable = new Runnable() {
					public void run() { 
						gameView.updatePreWin();		    
					}
				};
				SwingUtilities.invokeLater(doWorkRunnable);
			}
			else {
				gameView.updatePreWin();
			}
			this.firstHand = false;
		}
		Hand winningHand = null;
		if (winningCardPositions != null && winningCardPositions.length == 5) {
			if (!SwingUtilities.isEventDispatchThread()) {
				Runnable doWorkRunnable2 = new Runnable() {
					public void run() { 
						gameView.updateWin(seat, winningCardPositions, 7);
					}
				};
				SwingUtilities.invokeLater(doWorkRunnable2);
			}
			else {
				gameView.updateWin(seat, winningCardPositions, 7);
			}
			//this.gameView.updateHoldemWin(seat, winningCardPositions, 7);
			winningHand = new Hand();
			if (this.gameInfo.getPlayer(seat) != null && 
					this.gameInfo.getPlayer(seat).getRevealedHand() != null && 
					this.gameInfo.getPlayer(seat).getRevealedHand().size() > 1)
				for (int i = 0; i < 5; i++)
					winningHand.addCard(
							(winningCardPositions[i] < 2 ? 
									this.gameInfo.getPlayer(seat).getRevealedHand().getCard(winningCardPositions[i]) : 
										this.gameInfo.getBoard().getCard(winningCardPositions[i] - 2)));
		}
		for (int i = 0; i < this.players.length; i++)
			if (this.players[i] != null)
				this.players[i].winEvent(seat, amount, winningHand);
	}
	
}
