package com.asdf.plugins.pokergames.texasholdem.bots;

import com.asdf.plugins.pokergames.*;

/**
 * Simple pre-flop chart to use comparing 2-card hands.
 * @author teemu
 *
 */

public class SimplePFTable {

	
	public static double calcValue(Card c1, Card c2) {
		Card cc1 = c1;
		Card cc2 = c2;
		double value = 0;
		if (cc1.rank() < cc2.rank()) {
			cc1 = c2;
			cc2 = c1;
		}
		if (cc1.rank() == 12) {
			if (cc2.rank() == 12)
				value = 0.45;
			else if (cc2.rank() == 11) {
				if (cc1.suit() == cc2.suit())
					value = 1.65;
				else value = 3;
			}
			else if (cc2.rank() == 10) {
				if (cc1.suit() == cc2.suit())
					value = 3.3;
				else value = 5.7;
			}
			else if (cc2.rank() == 9) {
				if (cc1.suit() == cc2.suit())
					value = 4.05;
				else value = 7.95;
			}
			else if (cc2.rank() == 8) {
				if (cc1.suit() == cc2.suit())
					value = 6;
				else value = 11.4;
			}
			else if (cc2.rank() == 7) {
				if (cc1.suit() == cc2.suit())
					value = 8.55;
				else value = 15;
			}
			else if (cc2.rank() == 6) {
				if (cc1.suit() == cc2.suit())
					value = 11.7;
				else value = 20.1;
			}
			else if (cc2.rank() == 5) {
				if (cc1.suit() == cc2.suit())
					value = 12.3;
				else value = 21;
			}
			else if (cc2.rank() == 4) {
				if (cc1.suit() == cc2.suit())
					value = 16.8;
				else value = 28.5;
			}
			else if (cc2.rank() == 3) {
				if (cc1.suit() == cc2.suit())
					value = 16.5;
				else value = 29.4;
			}
			else if (cc2.rank() == 2) {
				if (cc1.suit() == cc2.suit())
					value = 17.1;
				else value = 38.85;
			}
			else if (cc2.rank() == 1) {
				if (cc1.suit() == cc2.suit())
					value = 22.2;
				else value = 39.75;
			}
			else if (cc2.rank() == 0) {
				if (cc1.suit() == cc2.suit())
					value = 23.4;
				else value = 51.45 + 3.8;
			}
		}
		else if (cc1.rank() == 11) {
			if (cc2.rank() == 11)
				value = 0.9;
			else if (cc2.rank() == 10) {
				if (cc1.suit() == cc2.suit())
					value = 4.35;
				else value = 9.45;
			}
			else if (cc2.rank() == 9) {
				if (cc1.suit() == cc2.suit())
					value = 6.3;
				else value = 15.9;
			}
			else if (cc2.rank() == 8) {
				if (cc1.suit() == cc2.suit())
					value = 8.25;
				else value = 23.1;
			}
			else if (cc2.rank() == 7) {
				if (cc1.suit() == cc2.suit())
					value = 12;
				else value = 27.6;
			}
			else if (cc2.rank() == 6) {
				if (cc1.suit() == cc2.suit())
					value = 18.3;
				else value = 50.75;
			}
			else if (cc2.rank() == 5) {
				if (cc1.suit() == cc2.suit())
					value = 18.6;
				else value = 48.75 + 3.8;
			}
			else if (cc2.rank() == 4) {
				if (cc1.suit() == cc2.suit())
					value = 26.4;
				else value = 52.35 + 3.8;
			}
			else if (cc2.rank() == 3) {
				if (cc1.suit() == cc2.suit())
					value = 26.7;
				else value = 53.25 + 3.8;
			}
			else if (cc2.rank() == 2) {
				if (cc1.suit() == cc2.suit())
					value = 30.45;
				else value = 54.15 + 3.8;
			}
			else if (cc2.rank() == 1) {
				if (cc1.suit() == cc2.suit())
					value = 34.35;
				else value = 55.95 + 3.8;
			}
			else if (cc2.rank() == 0) {
				if (cc1.suit() == cc2.suit())
					value = 34.65;
				else value = 58.65 + 3.8;
			}
		}
		else if (cc1.rank() == 10) {
			if (cc2.rank() == 10)
				value = 1.35;
			else if (cc2.rank() == 9) {
				if (cc1.suit() == cc2.suit())
					value = 7.05;
				else value = 18;
			}
			else if (cc2.rank() == 8) {
				if (cc1.suit() == cc2.suit())
					value = 9.75;
				else value = 24.3;
			}
			else if (cc2.rank() == 7) {
				if (cc1.suit() == cc2.suit())
					value = 16.2;
				else value = 35.55;
			}
			else if (cc2.rank() == 6) {
				if (cc1.suit() == cc2.suit())
					value = 30.15;
				else value = 42.75 + 3.8;
			}
			else if (cc2.rank() == 5) {
				if (cc1.suit() == cc2.suit())
					value = 31.05;
				else value = 55.05 + 3.8;
			}
			else if (cc2.rank() == 4) {
				if (cc1.suit() == cc2.suit())
					value = 34.05;
				else value = 56.85 + 3.8;
			}
			else if (cc2.rank() == 3) {
				if (cc1.suit() == cc2.suit())
					value = 37.05;
				else value = 57.75 + 3.8;
			}
			else if (cc2.rank() == 2) {
				if (cc1.suit() == cc2.suit())
					value = 41.85 + 3.8;
				else value = 67.65 + 4.7;
			}
			else if (cc2.rank() == 1) {
				if (cc1.suit() == cc2.suit())
					value = 44.55 + 3.8;
				else value = 68.55 + 4.7;
			}
			else if (cc2.rank() == 0) {
				if (cc1.suit() == cc2.suit())
					value = 49.35 + 3.8;
				else value = 72.15 + 4.7;
			}
		}
		else if (cc1.rank() == 9) {
			if (cc2.rank() == 9)
				value = 2.1;
			else if (cc2.rank() == 8) {
				if (cc1.suit() == cc2.suit())
					value = 10.5;
				else value = 25.8;
			}
			else if (cc2.rank() == 7) {
				if (cc1.suit() == cc2.suit())
					value = 13.35;
				else value = 32.85;
			}
			else if (cc2.rank() == 6) {
				if (cc1.suit() == cc2.suit())
					value = 24.6;
				else value = 39.75 + 3.8;
			}
			else if (cc2.rank() == 5) {
				if (cc1.suit() == cc2.suit())
					value = 31.95;
				else value = 50.55 + 3.8;
			}
			else if (cc2.rank() == 4) {
				if (cc1.suit() == cc2.suit())
					value = 43.05 + 3.8;
				else value = 59.55 + 3.8;
			}
			else if (cc2.rank() == 3) {
				if (cc1.suit() == cc2.suit())
					value = 45.75 + 3.8;
				else value = 69.45 + 4.7;
			}
			else if (cc2.rank() == 2) {
				if (cc1.suit() == cc2.suit())
					value = 49.05 + 3.8;
				else value = 70.35 + 4.7;
			}
			else if (cc2.rank() == 1) {
				if (cc1.suit() == cc2.suit())
					value = 72.45 + 4.7;
				else value = 78.75 + 4.7;
			}
			else if (cc2.rank() == 0) {
				if (cc1.suit() == cc2.suit())
					value = 73.05 + 4.7;
				else value = 80.85 + 4.7;
			}
		}
		else if (cc1.rank() == 8) {
			if (cc2.rank() == 8)
				value = 3.75;
			else if (cc2.rank() == 7) {
				if (cc1.suit() == cc2.suit())
					value = 13.05;
				else value = 33.75;
			}
			else if (cc2.rank() == 6) {
				if (cc1.suit() == cc2.suit())
					value = 18.9;
				else value = 36.75;
			}
			else if (cc2.rank() == 5) {
				if (cc1.suit() == cc2.suit())
					value = 30.75;
				else value = 41.55 + 3.8;
			}
			else if (cc2.rank() == 4) {
				if (cc1.suit() == cc2.suit())
					value = 43.35 + 3.8;
				else value = 44.25 + 3.8;
			}
			else if (cc2.rank() == 3) {
				if (cc1.suit() == cc2.suit())
					value = 49.65 + 3.8;
				else value = 71.25 + 4.7;
			}
			else if (cc2.rank() == 2) {
				if (cc1.suit() == cc2.suit())
					value = 72.75 + 4.7;
				else value = 77.85 + 4.7;
			}
			else if (cc2.rank() == 1) {
				if (cc1.suit() == cc2.suit())
					value = 73.35 + 4.7;
				else value = 81.75 + 4.7;
			}
			else if (cc2.rank() == 0) {
				if (cc1.suit() == cc2.suit())
					value = 79.05 + 4.7;
				else value = 91.5;
			}
		}
		else if (cc1.rank() == 7) {
			if (cc2.rank() == 7)
				value = 4.8;
			else if (cc2.rank() == 6) {
				if (cc1.suit() == cc2.suit())
					value = 14.1;
				else value = 37.95;
			}
			else if (cc2.rank() == 5) {
				if (cc1.suit() == cc2.suit())
					value = 26.1;
				else value = 40.65 + 3.8;
			}
			else if (cc2.rank() == 4) {
				if (cc1.suit() == cc2.suit())
					value = 38.85 + 3.8;
				else value = 63.15 + 4.7;
			}
			else if (cc2.rank() == 3) {
				if (cc1.suit() == cc2.suit())
					value = 59.85 + 3.8;
				else value = 66.75 + 4.7;
			}
			else if (cc2.rank() == 2) {
				if (cc1.suit() == cc2.suit())
					value = 76.95 + 4.7;
				else value = 82.65 + 4.7;
			}
			else if (cc2.rank() == 1) {
				if (cc1.suit() == cc2.suit())
					value = 79.35 + 4.7;
				else value =  92.4;
			}
			else if (cc2.rank() == 0) {
				if (cc1.suit() == cc2.suit())
					value = 83.25 + 4.7;
				else value = 93.3;
			}
		}
		else if (cc1.rank() == 6) {
			if (cc2.rank() == 6)
				value = 6.75;
			else if (cc2.rank() == 5) {
				if (cc1.suit() == cc2.suit())
					value = 19.2;
				else value = 40;
			}
			else if (cc2.rank() == 4) {
				if (cc1.suit() == cc2.suit())
					value = 31.65;
				else value = 47.85 + 3.8;
			}
			else if (cc2.rank() == 3) {
				if (cc1.suit() == cc2.suit())
					value = 46.05 + 3.8;
				else value =  62.25 + 4.7;
			}
			else if (cc2.rank() == 2) {
				if (cc1.suit() == cc2.suit())
					value = 61.35 + 4.7;
				else value = 74.85 + 4.7;
			}
			else if (cc2.rank() == 1) {
				if (cc1.suit() == cc2.suit())
					value = 82.95 + 4.7;
				else value =  94.2;
			}
			else if (cc2.rank() == 0) {
				if (cc1.suit() == cc2.suit())
					value = 90;
				else value = 95.1;
			}
		}
		else if (cc1.rank() == 5) {
			if (cc2.rank() == 5)
				value = 10.2;
			else if (cc2.rank() == 4) {
				if (cc1.suit() == cc2.suit())
					value = 24.9;
				else value = 41;
			}
			else if (cc2.rank() == 3) {
				if (cc1.suit() == cc2.suit())
					value = 35.85;
				else value =  45.45 + 3.8;
			}
			else if (cc2.rank() == 2) {
				if (cc1.suit() == cc2.suit())
					value = 60.15 + 4.7;
				else value = 65.85 + 4.7;
			}
			else if (cc2.rank() == 1) {
				if (cc1.suit() == cc2.suit())
					value = 73.65 + 4.7;
				else value =  84.15 + 4.7;
			}
			else if (cc2.rank() == 0) {
				if (cc1.suit() == cc2.suit())
					value = 90.3;
				else value = 97.8;
			}
		}
		else if (cc1.rank() == 4) {
			if (cc2.rank() == 4)
				value = 12.75;
			else if (cc2.rank() == 3) {
				if (cc1.suit() == cc2.suit())
					value = 31.35;
				else value = 64;
			}
			else if (cc2.rank() == 2) {
				if (cc1.suit() == cc2.suit())
					value = 38.55 + 3.8;
				else value = 64.05 + 4.7;
			}
			else if (cc2.rank() == 1) {
				if (cc1.suit() == cc2.suit())
					value = 60.45 + 4.7;
				else value =  75.75 + 4.7;
			}
			else if (cc2.rank() == 0) {
				if (cc1.suit() == cc2.suit())
					value = 73.95 + 4.7;
				else value = 96.9;
			}
		}
		else if (cc1.rank() == 3) {
			if (cc2.rank() == 3)
				value = 13.8;
			else if (cc2.rank() == 2) {
				if (cc1.suit() == cc2.suit())
					value = 38.25 + 3.8;
				else value = 64.95 + 4.7;
			}
			else if (cc2.rank() == 1) {
				if (cc1.suit() == cc2.suit())
					value = 60.75 + 4.7;
				else value =  76.65 + 4.7;
			}
			else if (cc2.rank() == 0) {
				if (cc1.suit() == cc2.suit())
					value = 61.05 + 4.7;
				else value = 85.05 + 4.7;
			}
		}
		else if (cc1.rank() == 2) {
			if (cc2.rank() == 2)
				value = 21.45;
			else if (cc2.rank() == 1) {
				if (cc1.suit() == cc2.suit())
					value = 79.65 + 4.7;
				else value = 96;
			}
			else if (cc2.rank() == 0) {
				if (cc1.suit() == cc2.suit())
					value = 79.95 + 4.7;
				else value = 99;
			}
		}
		else if (cc1.rank() == 1) {
			if (cc2.rank() == 1)
				value = 21.9;
			else if (cc2.rank() == 0) {
				if (cc1.suit() == cc2.suit())
					value = 90.6;
				else value = 100;
			}
		}
		else if (cc1.rank() == 0) {
			if (cc2.rank() == 0)
				value = 29.85;
		}
		
		return value;
	}
}