package com.asdf.client;

/**
 * Observer interface to monitor client
 * connecting and disconnecting.
 */
public interface ClientStateObserver {
	
	/**
	 * Client has been successfully connected to a server.
	 */
	void connected();	
	
	/**
	 * Client has been disconnected from the server.
	 * @param e Exception that caused disconnection
	 */
	void disconnected(Exception e);
}
