/**
 * 
 */
package com.asdf.common;

import java.nio.channels.SocketChannel;

/**
 * ChangeRequest is a request for NIO channel to change operation of the channel.
 * 
 * @author asdf
 *
 */
public class ChangeRequest {
	/**
	 * Register operation.
	 */
    public static final int REGISTER = 1;
    /**
     * Change operation.
     */
    public static final int CHANGEOPS = 2;
    /**
     * Write operation.
     */
    public static final int WRITE = 4;

    public SocketChannel socket;
    public int type;
    public int ops;
    
    /**
     * Constructs a new ChangeRequest.
     * 
     * @param socket Associated socket channel.
     * @param type Type of operation.
     * @param ops Operation to which channels operation should be changed to.
     */
    public ChangeRequest(SocketChannel socket, int type, int ops) {
      this.socket = socket;
      this.type = type;
      this.ops = ops;
    }
  }