package com.asdf.common;

public enum PokerGameTypes {
	HOLDEM_NO_LIMIT, HOLDEM_FIXED_LIMIT, HOLDEM_POT_LIMIT,
	FIVE_CARD_DRAW_NO_LIMIT, FIVE_CARD_DRAW_POT_LIMIT, FIVE_CARD_DRAW_FIXED_LIMIT,
	SEVEN_CARD_DRAW_NO_LIMIT, SEVEN_CARD_DRAW_POT_LIMIT, SEVEN_CARD_DRAW_FIXED_LIMIT,
	SEVEN_CARD_STUD_NO_LIMIT, SEVEN_CARD_STUD_FIXED_LIMIT, SEVEN_CARD_STUD_POT_LIMIT,
	OMAHA_NO_LIMIT, OMAHA_FIXED_LIMIT, OMAHA_POT_LIMIT;
	
	public boolean isHoldem(){
		if (this == HOLDEM_NO_LIMIT || this == HOLDEM_POT_LIMIT || this == HOLDEM_FIXED_LIMIT)
			return true;
		return false;
	}
	public boolean isPokerGame(){
		for (PokerGameTypes game : new PokerGameTypes[] {HOLDEM_NO_LIMIT, HOLDEM_FIXED_LIMIT, HOLDEM_POT_LIMIT,
				FIVE_CARD_DRAW_NO_LIMIT, FIVE_CARD_DRAW_POT_LIMIT, FIVE_CARD_DRAW_FIXED_LIMIT,
				SEVEN_CARD_DRAW_NO_LIMIT, SEVEN_CARD_DRAW_POT_LIMIT, SEVEN_CARD_DRAW_FIXED_LIMIT,
				SEVEN_CARD_STUD_NO_LIMIT, SEVEN_CARD_STUD_FIXED_LIMIT, SEVEN_CARD_STUD_POT_LIMIT,
				OMAHA_NO_LIMIT, OMAHA_FIXED_LIMIT, OMAHA_POT_LIMIT}) if (game==this)return true;
		return false;
	}
	
	public boolean isFixedLimit() {
		for (PokerGameTypes game : new PokerGameTypes[] {HOLDEM_FIXED_LIMIT, FIVE_CARD_DRAW_FIXED_LIMIT,
				SEVEN_CARD_DRAW_FIXED_LIMIT, SEVEN_CARD_STUD_FIXED_LIMIT, OMAHA_FIXED_LIMIT})
			if (game==this)return true;
		return false;				
	}

	public boolean isDiscardable() {
		for (PokerGameTypes game : new PokerGameTypes[] {FIVE_CARD_DRAW_NO_LIMIT, FIVE_CARD_DRAW_POT_LIMIT,
			SEVEN_CARD_DRAW_POT_LIMIT, SEVEN_CARD_DRAW_FIXED_LIMIT,FIVE_CARD_DRAW_POT_LIMIT,
			SEVEN_CARD_DRAW_NO_LIMIT})
				if (game==this) return true;
		return false;
			
	}
	public boolean isNoLimit(){
		for (PokerGameTypes game : new PokerGameTypes[] {HOLDEM_NO_LIMIT,FIVE_CARD_DRAW_NO_LIMIT,
				SEVEN_CARD_DRAW_NO_LIMIT, SEVEN_CARD_STUD_NO_LIMIT, OMAHA_NO_LIMIT})
					if (game==this) return true;
		return false;
	}
	public boolean isPotLimit(){
		for (PokerGameTypes game : new PokerGameTypes[] {HOLDEM_POT_LIMIT, FIVE_CARD_DRAW_POT_LIMIT,
				SEVEN_CARD_DRAW_POT_LIMIT, SEVEN_CARD_STUD_POT_LIMIT, OMAHA_POT_LIMIT})
					if (game==this) return true;
		return false;
	}
	
}

