package com.asdf.gui.connect;

import java.awt.Dimension;
import java.awt.GridLayout;
import java.awt.Rectangle;

import javax.swing.JFrame;
import javax.swing.SwingUtilities;

/**
 * Frame containing connecting screen. This frame is
 * shown first when user starts the client. Frame is also
 * shown when ConnectionHandler encounters disconnection.
 */
public class ConnectFrame extends JFrame {
	
	/**
	 * Default serial.
	 */
	private static final long serialVersionUID = 1L;
	
	public ConnectFrame() {
		super();
		
		//Set Look & Feel
        try {
            javax.swing.UIManager.setLookAndFeel(javax.swing.UIManager.getSystemLookAndFeelClassName());
        } catch(Exception e) {
            e.printStackTrace();
        }
        initGUI();
	}
	
	/**
     * Initializes GUI for connection frame. 
     */
	private void initGUI() {
		setTitle("Poker");
		
		getContentPane().setLayout(new GridLayout(1,1));
		setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		ConnectPanel p = new ConnectPanel(this);
	//	p.setSize(640, 480);
		
		getContentPane().add(p);
		this.setPreferredSize(new Dimension(640, 480));
		this.setMaximizedBounds(new Rectangle(0,0,640,480));
		this.setMaximumSize(new Dimension(640, 480));
		this.setMinimumSize(new Dimension(320, 240));
		this.setSize(700, 600);
		setVisible(true);
	}
	
	/**
	* Main method to display this JFrame
	*/
	public static void main(String[] args) {
		SwingUtilities.invokeLater(new Runnable() {
			public void run() {
				ConnectFrame inst = new ConnectFrame();
				inst.setLocationRelativeTo(null);
				inst.setVisible(true);
			}
		});
	}
}
