package com.asdf.gui.lobby;

import java.awt.Color;
import java.awt.Dimension;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.Insets;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.FocusAdapter;
import java.awt.event.FocusEvent;

//import javax.swing.ComboBoxModel;
//import javax.swing.DefaultComboBoxModel;
import javax.swing.JButton;
//import javax.swing.JComboBox;
import javax.swing.JLabel;
import javax.swing.JPasswordField;
import javax.swing.JTextField;

import com.asdf.client.LobbyController;

/**
 * Popup panel to create new accounts used in lobby.
 * 
 */
public class LobbyCreateAccountPanel extends javax.swing.JFrame {
	/**
	 * Default Serial.
	 */
	private static final long serialVersionUID = 1L;

	private JLabel NameLabel;
	private JLabel passwdLabel;
	private JLabel confirmPasswdLabel;
	private JPasswordField passwdField;
	private JButton createButton;
	//private JComboBox accountChooser;
	private JPasswordField confimPasswdField;
	private JTextField accountField;
	//private JLabel accountTypeLabel;
	
	private LobbyController controller = null;

	/**
	 * Sole constructor.
	 * 
	 * @param controller LobbyController
	 */
	public LobbyCreateAccountPanel(LobbyController controller) {
		super();
		this.controller = controller;
		initGUI();
	}
	
	/**
	 * Initializes GUI.
	 */
	private void initGUI() {
		try {
			GridBagLayout thisLayout = new GridBagLayout();
			setPreferredSize(new Dimension(350, 120));
			thisLayout.rowWeights = new double[] {0.1, 0.1, 0.1, 0.1, 0.1};
			thisLayout.rowHeights = new int[] {7, 7, 7, 7, 7};
			thisLayout.columnWeights = new double[] {0.1, 0.2};
			thisLayout.columnWidths = new int[] {100, 200};
			this.setLayout(thisLayout);
			{
				NameLabel = new JLabel();
				this.add(NameLabel, new GridBagConstraints(0, 0, 1, 1, 0.0, 0.0, GridBagConstraints.CENTER, GridBagConstraints.HORIZONTAL, new Insets(0, 0, 0, 0), 0, 0));
				NameLabel.setText("Account name");
				NameLabel.setToolTipText("Enter account name you want.");
			}
			{
				passwdLabel = new JLabel();
				this.add(passwdLabel, new GridBagConstraints(0, 1, 1, 1, 0.0, 0.0, GridBagConstraints.CENTER, GridBagConstraints.HORIZONTAL, new Insets(0, 0, 0, 0), 0, 0));
				passwdLabel.setText("Password");
			}
			{
				confirmPasswdLabel = new JLabel();
				this.add(confirmPasswdLabel, new GridBagConstraints(0, 2, 1, 1, 0.0, 0.0, GridBagConstraints.CENTER, GridBagConstraints.HORIZONTAL, new Insets(0, 0, 0, 0), 0, 0));
				confirmPasswdLabel.setText("Confirm password");
			}
			/*{
				accountTypeLabel = new JLabel();
				this.add(accountTypeLabel, new GridBagConstraints(0, 3, 1, 1, 0.0, 0.0, GridBagConstraints.CENTER, GridBagConstraints.HORIZONTAL, new Insets(0, 0, 0, 0), 0, 0));
				accountTypeLabel.setText("Account type");
				accountTypeLabel.setToolTipText("If you are unsure what kind of account you need, select \"Regular\".");
			}*/
			{
				accountField = new JTextField();
				this.add(accountField, new GridBagConstraints(1, 0, 1, 1, 0.0, 0.0, GridBagConstraints.CENTER, GridBagConstraints.HORIZONTAL, new Insets(0, 0, 0, 0), 0, 0));
				accountField.setToolTipText("Enter account name you want.");
			}
			{
				passwdField = new JPasswordField();
				this.add(passwdField, new GridBagConstraints(1, 1, 1, 1, 0.0, 0.0, GridBagConstraints.CENTER, GridBagConstraints.HORIZONTAL, new Insets(0, 0, 0, 0), 0, 0));

			}
			{
				confimPasswdField = new JPasswordField();
				this.add(confimPasswdField, new GridBagConstraints(1, 2, 1, 1, 0.0, 0.0, GridBagConstraints.CENTER, GridBagConstraints.HORIZONTAL, new Insets(0, 0, 0, 0), 0, 0));
				confimPasswdField.addFocusListener(new FocusAdapter() {
					public void focusLost(FocusEvent evt) {
						if(new String(passwdField.getPassword()).equalsIgnoreCase(new String(confimPasswdField.getPassword()))){
							createButton.setText("Create Account");
							createButton.setForeground(Color.BLACK);
						}else{
							createButton.setText("error: password and confirm password do not match");
							createButton.setForeground(Color.RED);
						}		
					}
				});
			}
			/*{
				ComboBoxModel accountChooserModel = 
					new DefaultComboBoxModel(
							new String[] { "REGULAR_USER", "BOT_USER" });
				accountChooser = new JComboBox();
				this.add(accountChooser, new GridBagConstraints(1, 3, 1, 1, 0.0, 0.0, GridBagConstraints.CENTER, GridBagConstraints.HORIZONTAL, new Insets(0, 0, 0, 0), 0, 0));
				accountChooser.setModel(accountChooserModel);
				accountChooser.setToolTipText("If you are unsure what kind of account you need, select \"REGULAR_USER\".");
			}*/
			{
				createButton = new JButton();
				this.add(createButton, new GridBagConstraints(0, 4, 2, 1, 0.0, 0.0, GridBagConstraints.CENTER, GridBagConstraints.HORIZONTAL, new Insets(0, 0, 0, 0), 0, 0));
				createButton.setText("Create Account");
				createButton.setToolTipText("Creates you a new user account with given name if account with same name does not already exist.");
				createButton.addFocusListener(new FocusAdapter() {
					public void focusLost(FocusEvent evt) {
						createButton.setText("Create Account");
						createButton.setForeground(Color.BLACK);
					}
				});					
				createButton.addActionListener(new ActionListener() {
					public void actionPerformed(ActionEvent evt) {
						if(new String(passwdField.getPassword()).equalsIgnoreCase(new String(confimPasswdField.getPassword()))){
							controller.requestCreateAccount(accountField.getText(), new String(passwdField.getPassword()), /*accountChooser.getSelectedItem().toString()*/"REGULAR_USER");
							dispose();
						}else{
							createButton.setText("error: password and confirm password do not match");
							createButton.setForeground(Color.RED);
						}					
						
					}
				});
			}
		} catch (Exception e) {
			e.printStackTrace();
		}
	}

}
