package com.asdf.gui.lobby;

import java.awt.Dimension;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.GridLayout;
import java.awt.Insets;
import javax.swing.BorderFactory;
import javax.swing.JButton;
import javax.swing.JCheckBox;

import javax.swing.WindowConstants;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JTextField;

public class LobbyRightPanelCreate extends javax.swing.JPanel {
	
	/**
	 * Default serial.
	 */
	private static final long serialVersionUID = 1L;
	
    private JPanel topPanel;
    private JPanel bottomPanel;
    private JButton createButton;
    private JCheckBox simulation;
    private JTextField nameField;
    private JLabel name;

	{
		//Set Look & Feel
		try {
			javax.swing.UIManager.setLookAndFeel(javax.swing.UIManager.getSystemLookAndFeelClassName());
		} catch(Exception e) {
			e.printStackTrace();
		}
	}


    /**
    * Auto-generated main method to display this 
    * JPanel inside a new JFrame.
    */
    public static void main(String[] args) {
        JFrame frame = new JFrame();
        GridLayout frameLayout = new GridLayout(1, 1);
        frameLayout.setColumns(1);
        frameLayout.setHgap(5);
        frameLayout.setVgap(5);
        frame.getContentPane().setLayout(frameLayout);
        frame.getContentPane().add(new LobbyRightPanelCreate());
        frame.setDefaultCloseOperation(WindowConstants.DISPOSE_ON_CLOSE);
        frame.pack();
        frame.setVisible(true);
    }
    
    public LobbyRightPanelCreate() {
        super();
        initGUI();
    }
    
    private void initGUI() {
        try {
            GridBagLayout thisLayout = new GridBagLayout();
            thisLayout.rowWeights = new double[] {0.0, 0.0, 0.1, 0.0, 0.0};
            thisLayout.rowHeights = new int[] {56, 7, 180, 7, 7};
            thisLayout.columnWeights = new double[] {0.1};
            thisLayout.columnWidths = new int[] {7};
            this.setLayout(thisLayout);
            setPreferredSize(new Dimension(400, 300));
            {
                topPanel = new JPanel();
                GridBagLayout topPanelLayout = new GridBagLayout();
                this.add(topPanel, new GridBagConstraints(0, 0, 1, 1, 0.0, 0.0, GridBagConstraints.CENTER, GridBagConstraints.BOTH, new Insets(2, 2, 2, 2), 0, 0));
                topPanelLayout.rowWeights = new double[] {0.1, 0.1};
                topPanelLayout.rowHeights = new int[] {7, 7};
                topPanelLayout.columnWeights = new double[] {0.0, 0.1};
                topPanelLayout.columnWidths = new int[] {99, 7};
                topPanel.setLayout(topPanelLayout);
                topPanel.setBorder(BorderFactory.createTitledBorder("New Game"));
                {
                    name = new JLabel();
                    topPanel.add(name, new GridBagConstraints(0, 0, 1, 1, 0.0, 0.0, GridBagConstraints.CENTER, GridBagConstraints.BOTH, new Insets(0, 0, 0, 0), 0, 0));
                    name.setText("Name");
                    name.setHorizontalAlignment(JLabel.CENTER);
                }
                {
                    nameField = new JTextField();
                    topPanel.add(nameField, new GridBagConstraints(1, 0, 1, 1, 0.0, 0.0, GridBagConstraints.CENTER, GridBagConstraints.BOTH, new Insets(0, 0, 0, 0), 0, 0));
                }
                {
                	simulation = new JCheckBox();
                	topPanel.add(simulation, new GridBagConstraints(0, 1, 2, 1, 0.0, 0.0, GridBagConstraints.CENTER, GridBagConstraints.BOTH, new Insets(0, 30, 0, 0), 0, 0));
                	simulation.setText("Simulation game");
                }
            }
            {
                bottomPanel = new JPanel();
                GridBagLayout jPanel1Layout = new GridBagLayout();
                jPanel1Layout.columnWidths = new int[] {7, 7, 7, 7};
                jPanel1Layout.rowHeights = new int[] {7, 7, 7, 7};
                jPanel1Layout.columnWeights = new double[] {0.1, 0.1, 0.1, 0.1};
                jPanel1Layout.rowWeights = new double[] {0.1, 0.1, 0.1, 0.1};
                this.add(bottomPanel, new GridBagConstraints(0, 2, 1, 1, 0.0, 0.0, GridBagConstraints.CENTER, GridBagConstraints.BOTH, new Insets(2, 2, 2, 2), 0, 0));
                bottomPanel.setLayout(jPanel1Layout);
            }
            {
                createButton = new JButton();
                this.add(createButton, new GridBagConstraints(0, 4, 1, 1, 0.0, 0.0, GridBagConstraints.CENTER, GridBagConstraints.BOTH, new Insets(2, 2, 2, 2), 1, 1));
                createButton.setText("Create");
            }
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

}
