package com.asdf.gui.lobby;

import java.awt.Graphics;

import javax.swing.JTable;

/**
 * JTable derivative that displays message to user
 * if dataModel has no rows.
 */
public class LobbyTable extends JTable {
	
	/**
	 * Default UID
	 */
	private static final long serialVersionUID = 1L;

	/**
	 * Overridden paint function to draw text in the
	 * middle of the control if there are no rows
	 * to display.
	 * @param g Graphics
	 */
	@Override
	protected void paintComponent(Graphics g) {
		super.paintComponent(g);
		if (dataModel != null && dataModel.getRowCount() == 0) {
			g.drawString("No games running or no games match your search terms.",
					(this.getWidth() / 2) - 200, (this.getHeight() / 2));
			g.drawString("Please create a game, choose another game type or redefine your search.",
					(this.getWidth() / 2) - 200, (this.getHeight() / 2) + 15);
			 
		}
	}
}
