package com.asdf.server;

import java.io.IOException;

import com.asdf.common.Logger;

/**
 * Initializes Server instance and runs it.
 */
public class Main 
{
	/**
	 * main
	 * Entry point of the GameServer application,
	 * @param args Command line arguments
	 */
	public static void main(String[] args) throws IOException  {
		Logger.get().info("Starting server");
		try {
			Server s = new Server();
			s.run();
		}
		catch(IOException e) {
			Logger.get().severe("Failure: "+e.getMessage());
			Logger.get().throwing("Server", "run", e);
			throw e;
		}
	}

}
