package com.asdf.test;

import java.util.List;
import java.util.Random;

import org.w3c.dom.Element;
import org.w3c.dom.Node;

import com.asdf.common.Game;
import com.asdf.common.GameTimerTask;
import com.asdf.common.Logger;
import com.asdf.parser.GameDetailsResponse;
import com.asdf.parser.GameRequest;
import com.asdf.parser.GameResponse;
import com.asdf.parser.GenericResponse;

/**
 * Game for testing purposes
 */
public class TestGamePlugin extends Game {

	private GameTimerTask task;
	private long sessionID;
	
	public TestGamePlugin() {
	}
	
//	@Override
//	public boolean handleJoinRequest(long sessionID, GameRequest request) {
//		if (request.getJoin().getParameters() != null) {
//			List<Element> params = request.getJoin().getParameters().getAny();
//			for(Element e : params) {
//				if (e.getNodeName() == "Cheats") {
//					if (e.getAttribute("enabled").equalsIgnoreCase("true")) {
//						Logger.get().fine("cheats enabled");
//					}
//				}
//			}
//		}
//		this.sessionID = sessionID;
//		return true;
//	}

	@Override
	public void handleRequest(long sessionID, GameRequest request) {
		if (request.getJoin() != null) {
			if (request.getJoin().getParameters() != null) {
				List<Element> params = request.getJoin().getParameters().getAny();
				for(Element e : params) {
					if (e.getNodeName() == "Cheats") {
						if (e.getAttribute("enabled").equalsIgnoreCase("true")) {
							Logger.get().fine("cheats enabled");
						}
					}
				}
			}
			this.sessionID = sessionID;
		}
		
		if (request.getCreate() != null) {
			Logger.get().fine("Listing parameters");
			if (request.getCreate().getParameters() != null) {
				for(Element e : request.getCreate().getParameters().getAny()) {
					Logger.get().fine("Parameter element:" + e.getNodeName());
					for (int i = 0; i < e.getAttributes().getLength(); i++) {
						Node n = e.getAttributes().item(i);
						Logger.get().info("Attribute:" + n.getNodeName() + " value:" + n.getNodeValue());
					}
				}
			}
		}
		if (request.getAction() != null) {
			if (request.getAction().getParameters() != null) {
				Element e = request.getAction().getParameters().getAny().get(0);
				if (e.getNodeName().equals("settimer")) {
					task = new GameTimerTask(this) {

						@Override
						public void onTick() {
							onTimer();
						}
						
					};
					Random m = new Random();
					m.setSeed(System.currentTimeMillis());
					long delay = m.nextInt(1000);
					setTimer(task, delay);
					
				}
			}
		}
	}

	@Override
	public void handleResponse(long sessionID, GameResponse response) {
		// TODO Auto-generated method stub

	}

	@Override
	protected com.asdf.parser.GameListResponse.Games.Game description() {
		// TODO Auto-generated method stub
		return null;
	}

	@Override
	protected void details(GameDetailsResponse a) {
		// TODO Auto-generated method stub
		
	}

	protected void onTimer() {
		GameResponse gameres = new GameResponse();
		GenericResponse gres = new GenericResponse();
		gres.setSuccess(true);
		gameres.setAction(gres);
		send(sessionID, gameres);
	}

	@Override
	protected String[] columnNames() {
		return new String[]{};
	}

	@Override
	public void die() {
		// TODO Auto-generated method stub
		
	}

}
