package com.asdf.test;

import java.io.FileOutputStream;
import org.junit.Test;
import com.asdf.parser.*;
import com.asdf.utils.XMLTools;

/** 
 * This shows how to use JAXB to update the unmarshalled content tree 
 * then marshal it back to xml document
 */
public class XmlParsingTest {

	/**
	 * testMarshalling
	 * Tries to marshal Message from xml document
	 * and then unmarshal it back.
	 */
	@Test(timeout=2000)
	public void testMarshalling() throws Exception {
		XMLTools tools = new XMLTools();

		Message m = (Message) tools.loadMessageFromFile(
				"testmaterial/CreateAccount.xml");

		GameResponse game = new GameResponse();
		Response res = new Response();
		game.setGameID((long)1234);
		GenericResponse gres = new GenericResponse();
		gres.setSuccess(true);
		game.setJoin(gres);
		res.setGame(game);
		m.setRequest(null);
		m.setResponse(res);

		
		String outpath = "output/output_CreateAccount.xml";
		System.out.println("Results of unmarshalling in " + outpath);
		byte[] bytes = tools.messageToBytes(m);
		FileOutputStream fos = new FileOutputStream(outpath);
		fos.write(bytes);
		fos.close();
	}
}
