package com.asdf.utils;

import org.w3c.dom.Attr;
import org.w3c.dom.DOMException;
import org.w3c.dom.Document;
import org.w3c.dom.Element;
import org.w3c.dom.NamedNodeMap;
import org.w3c.dom.Node;
import org.w3c.dom.NodeList;
import org.w3c.dom.TypeInfo;
import org.w3c.dom.UserDataHandler;

/**
 * An Element implementation for basic functionality required by networking.
 * 
 *
 */

public class BasicElement implements Element {
	private String name;
	private String string;

	private BasicNodeList childNodes = new BasicNodeList();
	private BasicNamedNodeMap attributes = new BasicNamedNodeMap();

	public BasicElement() {}
	
	public BasicElement(String text) {
		name = text;
	}
	
	public String getAttribute(String name) {
		return attributes.getNamedItem(name).getNodeValue();
	}

	public String getAttributeNS(String namespaceURI, String localName) throws DOMException {
		return null;
	}

	public Attr getAttributeNode(String name) {
		return (Attr)attributes.getNamedItem(name);
	}

	public Attr getAttributeNodeNS(String namespaceURI, String localName) throws DOMException {
		return null;
	}

	public NodeList getElementsByTagName(String name) {
		return null;
	}

	public NodeList getElementsByTagNameNS(String namespaceURI, String localName) throws DOMException {
		return null;
	}

	public TypeInfo getSchemaTypeInfo() {
		return null;
	}

	public String getTagName() {
		return name;
	}

	public boolean hasAttribute(String name) {
		return attributes.getNamedItem(name) != null;
	}

	public boolean hasAttributeNS(String namespaceURI, String localName) throws DOMException {
		return false;
	}

	public void removeAttribute(String name) throws DOMException {
		attributes.removeNamedItem(name);
	}

	public void removeAttributeNS(String namespaceURI, String localName) throws DOMException {
	}

	public Attr removeAttributeNode(Attr oldAttr) throws DOMException {
		attributes.removeNamedItem(oldAttr.getName());
		return oldAttr;
	}

	public void setAttribute(String name, String value) throws DOMException {
		BasicAttr attr = new BasicAttr(this, name, value);
		attributes.setNamedItem(attr);
	}

	public void setAttributeNS(String namespaceURI, String qualifiedName, String value) throws DOMException {
	}

	public Attr setAttributeNode(Attr newAttr) throws DOMException {
		attributes.setNamedItem(newAttr);
		return newAttr;
	}

	public Attr setAttributeNodeNS(Attr newAttr) throws DOMException {
		return null;
	}

	public void setIdAttribute(String name, boolean isId) throws DOMException {
	}

	public void setIdAttributeNS(String namespaceURI, String localName, boolean isId) throws DOMException {
	}

	public void setIdAttributeNode(Attr idAttr, boolean isId) throws DOMException {
	}

	public Node appendChild(Node newChild) throws DOMException {
		childNodes.add(newChild);
		return null;
	}

	public Node cloneNode(boolean deep) {
		return null;
	}

	public short compareDocumentPosition(Node other) throws DOMException {
		return 0;
	}

	public NamedNodeMap getAttributes() {
		return attributes;
	}

	public String getBaseURI() {
		// TODO Auto-generated method stub
		return null;
	}

	public NodeList getChildNodes() {
		return childNodes;
	}

	public Object getFeature(String feature, String version) {
		// TODO Auto-generated method stub
		return null;
	}

	public Node getFirstChild() {
		if (childNodes.size() > 0)
			return childNodes.get(0);
		else
			return null;
	}

	public Node getLastChild() {
		if (childNodes.size() > 0)
			return childNodes.get(childNodes.size() - 1);
		else
			return null;
	}

	public String getLocalName() {
		// TODO Auto-generated method stub
		return null;
	}

	public String getNamespaceURI() {
		// TODO Auto-generated method stub
		return null;
	}

	public Node getNextSibling() {
		// TODO Auto-generated method stub
		return null;
	}

	public String getNodeName() {
		return name;
	}

	public short getNodeType() {
		return Node.ELEMENT_NODE;
	}

	public String getNodeValue() throws DOMException {
		return string;
	}

	public Document getOwnerDocument() {
		// TODO Auto-generated method stub
		return null;
	}

	public Node getParentNode() {
		// TODO Auto-generated method stub
		return null;
	}

	public String getPrefix() {
		// TODO Auto-generated method stub
		return null;
	}

	public Node getPreviousSibling() {
		// TODO Auto-generated method stub
		return null;
	}

	public String getTextContent() throws DOMException {
		// TODO Auto-generated method stub
		return null;
	}

	public Object getUserData(String key) {
		return null;
	}

	public boolean hasAttributes() {
		return false;
	}

	public boolean hasChildNodes() {
		return false;
	}

	public Node insertBefore(Node newChild, Node refChild) throws DOMException {
		return null;
	}

	public boolean isDefaultNamespace(String namespaceURI) {
		return false;
	}

	public boolean isEqualNode(Node arg) {
		return false;
	}

	public boolean isSameNode(Node other) {
		return false;
	}

	public boolean isSupported(String feature, String version) {
		return false;
	}

	public String lookupNamespaceURI(String prefix) {
		return null;
	}

	public String lookupPrefix(String namespaceURI) {
		return null;
	}

	public void normalize() {
	}

	public Node removeChild(Node oldChild) throws DOMException {
		int index = childNodes.indexOf(oldChild);
		if (index == -1)
			throw new DOMException(DOMException.NOT_FOUND_ERR, "NOT FOUND!!111");
		Node n = childNodes.get(index);
		childNodes.remove(index);
		return n;
	}

	public Node replaceChild(Node newChild, Node oldChild) throws DOMException {
		int index = childNodes.indexOf(oldChild);
		if (index == -1)
			throw new DOMException(DOMException.NOT_FOUND_ERR, "NOT FOUND!!111");
		childNodes.set(index, newChild);
		return oldChild;
	}

	public void setNodeValue(String nodeValue) throws DOMException {
		string = nodeValue;
	}

	public void setPrefix(String prefix) throws DOMException {
	}

	public void setTextContent(String textContent) throws DOMException {			
	}

	public Object setUserData(String key, Object data, UserDataHandler handler) {
		return null;
	}
}
