package com.asdf.utils;

/**
 * Describes the offset of a chip instance from the center of the
 * applicable area.
 *
 */
public class ChipOffSet implements Comparable<ChipOffSet> {
	
	/**
	 * Default constructor. Sets value to -1 and offsets to zero.
	 *
	 */
	public ChipOffSet() {
		value = -1;
		off_x = 0;
		off_y = 0;
	}
	
	/**
	 * Constructor. Sets offsets and chip value to correct measures.
	 * @param val Value of the chip.
	 * @param offx Offset on x-axis.
	 * @param offy Offset on y-axis.
	 */
	public ChipOffSet(int val, int offx, int offy) {
		value = val; off_x = offx; off_y = offy;
	}
	
	public int value, off_x, off_y, on_top = 0;
	boolean on_top_of_something = false;

	/**
	 * Comparator. Ensures that chip piles are shown on top.
	 */
	public int compareTo(ChipOffSet o) {
		if(on_top_of_something || on_top > 0){
			if(!o.on_top_of_something || o.on_top > 0)
					return 0;
			else
				return -1;
		}else{
			if(off_y > o.off_y)
				return 0;
			else
				return 1;
		}

	}
	
	/**
	 * Sets this chip to be on top.
	 *
	 */
	public void setOnTop(){
		on_top_of_something = true;
	}

	/**
	 * Increases topness of this chip.
	 *
	 */
	public void addOnTop(){
		on_top++;
	}


}
