package com.asdf.utils;

import java.util.Random;
import java.util.Collections;

/**
 * ChipSpreader distributes chips on a 2-dimentional normal distribution
 * and generates the appropriate amount of such chips.
 * 
 *
 */
public class ChipSpreader {

	/// Different values of chips. Index describes the graphics that is used to show it.
	private static double[] chipValues = {1000, 500, 50, 10, 5, 1, 0.5, 0.1, 0.01};
	static Random gen = new Random();
	
	/**
	 * Distributes an amount of $$ to some number of chips on the table before the player.
	 * @param money Amount of money to be distributed.
	 * @return A sorted distribution of the chips.
	 */
	public static Distribution distribute(double money) {
		
		Distribution distr = new Distribution();
		
		for(int i=0; i<chipValues.length; i++) {
			while(chipValues[i] <= money) {
				int offx = (int)(gen.nextGaussian() * 14);
				int offy = (int)(gen.nextGaussian() * 6);
				
				while(offx * offx > 70 * 70) {
					offx >>= 1;
				}
				
				while(offy * offy > 45 * 45) {
					offy >>= 1;
				}
				
				// int tmp = (int) (Math.random() * (chipValues.length - i));
				
				distr.add(offx, offy, i);
				money -= chipValues[i];
			}
		}
		
		Collections.sort(distr.chips);
		//Collections.reverse(distr.chips);
		
		return distr;
	}
	
}
