
package com.asdf.utils;

/**
 * Contains common constants used in client
 * server implementation.
 */
public class ClientServerConstants {
	
	/**
     * If message is longer than this, it is considered garbage.
     */
    public static final int TOO_BIG_MESSAGE = 1<<20;
    
    /**
     * Select() call timeout. Enables non-blocking operation.
     */
    public static final int SELECT_TIMEOUT = 100;
    
    /**
     * Determines the ratio limit on which to release
     * buffer and allocate new smaller one to prevent
     * wasting memory.
     */
    public static final int WASTING_MEM_RATIO = 5;
    
    /** 
     * Protocol port
     */
	public static final int PORT = 49152;
	
	/**
	 * Connecting timeout for client. 3 seconds.
	 */
	public static final int CONNECT_TIMEOUT = 3000;
}
